var alertLevel = 1000;
var notifyOnDateChange = true;


var win;
if (typeof (PopupWindow) == "function")
    win = new PopupWindow();

/*
Bug 1021 : 2.7 LPD-396 Spend module:  Clicking on Enter brings up the calendar
This function prevents Enter key to submit the form unnecessarily (handles key pressed on textbox only).
*/
/* Code change starts here */
function onKeyPressPreventEnterKey(evt) {
    var evt = (evt) ? evt : ((event) ? event : null);
    var node = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);
    if ((evt.keyCode == 13) && (node.type == "text")) {
        if (node.id.search("txtDate") < 0) {
            return false;
        } else {
            var btnDate = document.getElementById(node.id.substring(0, node.id.length - "_txtDate".length) + "_button"); //when textdate then open calendar.
            btnDate.click();
            return false;
        }
    }
}

document.onkeypress = onKeyPressPreventEnterKey;
/*  Code change ends here */

function ShowMaxLimitTextArea(e, taObj, fieldName, maxLen) {

    e = e || window.event;
    var unicode = e.charCode ? e.charCode : e.keyCode ? e.keyCode : 0;
    if (unicode >= 48) {
        var maxL = maxLen;
        var valueMax = ValidatorGetValue(taObj.id);
        //Resolved bug 1433 2.7: Data Validation Popup issue. asking about the length popup
        if (valueMax.length > maxLen && $(taObj).attr('isMask') == undefined) {
            //            if(maxLen > 2001)
            //            {
            //                taObj.value = valueMax.substring(0, 2001);
            //            }
            //            else
            //            {
            var nbrLines = 0;
            //                 if(Sys.Browser.agent == Sys.Browser.InternetExplorer)
            //                {
            //                    nbrLines = 0;
            //                }
            //                else 
            //                {
            //nbrLines = valueMax.split("\n").length;
            //                }
            var reqString = valueMax.substring(0, maxL);
            nbrLines = reqString.split("\n").length;
            taObj.value = reqString.substring(0, (maxL - nbrLines));
            //taObj.value = valueMax.substring(0, maxL);
            //}

            var alertMessage = fieldName + ' can only accept ' + maxL + ' characters.';
            alert(alertMessage);
            return false;
        }
    }
}

function ShowMaxLimit(e, taObj, fieldName) {
    e = e || window.event;
    var unicode = e.charCode ? e.charCode : e.keyCode ? e.keyCode : 0;
    if (unicode >= 48) {
        var maxL = taObj.maxLength;
        //Resolved bug 1433 2.7: Data Validation Popup issue. asking about the length popup
        if (taObj.value.length == maxL && $(taObj).attr('isMask') == undefined) {
            var alertMessage = fieldName + ' can only accept ' + maxL + ' characters.';
            alert(alertMessage);
            return false;
        }
    }
}



function OpenWelcomePage(url) {
    var tstURL = 'WelcomePage.aspx';
    var oWnd1 = radopen(tstURL, "RWObjectEntity");
    var iHeight = parseInt(320);
    var iWidth = parseInt(500);
    oWnd1.setSize(iWidth, iHeight);
    var iLeft = parseInt(window.screen.availWidth) / 2;
    var iTop = parseInt(window.screen.availHeight) / 2;
    iLeft = parseInt(iLeft) - parseInt(250);
    iTop = parseInt(iTop) - parseInt(300);
    oWnd1.moveTo(iLeft, iTop);
    //oWnd1.center();
    oWnd.setActive()
    oWnd1.show();
    return false;
}



function LogOutSession() {

    // TestAlert(window.location + " causing timer ticking3!")

    needToConfirm = false;
    window.parent.location.href = "Default.aspx?Logoff=true&Timeout=true";
    return false;
}


var timeChangeTitle = null;
var timeForceSessionOut = null;


function AlertSessionTimeout() {

    //go to server asynchronously, and get the latest accessed time for user
    //if server latest access time minus this page load time>sessionTimeOut Period, continue, else skip processing...
    // TestAlert("calling gettime");
    PageMethods.SkipOrApplyAutoSessionExpirationLogic('', OnCallComplete, OnCallError);
    //TestAlert("back from get time");

}

function DisableFrameTop() {
    var fBanner = null;
    var dvBlock = null;
    try {
        fBanner = window.parent.frames['banner'];
        dvBlock = fBanner.document.getElementById('dvBlock');
    }
    catch (e) {
        dvBlock = parent.document.getElementById('banner').contentWindow.document.getElementById('dvBlock');
    }
    dvBlock.style.display = 'block';
}

function EnableFrameTop() {
    var fBanner = null;
    var dvBlock = null;
    try {
        fBanner = window.parent.frames['banner'];
        dvBlock = fBanner.document.getElementById('dvBlock');
    }
    catch (e) {
        dvBlock = parent.document.getElementById('banner').contentWindow.document.getElementById('dvBlock');
    }
    //alert(window.parent.location);
    dvBlock.style.display = 'none';
    //var oneLess = parseInt(parseInt(timeSessionOut) * 1000 * 60) - 60000;
    //TFS 1493- no of minutes sesssion timeout pop remain active as per configuration setting.
    var oneLess = parseInt(parseInt(timeSessionOut) * 1000 * 60) - parseInt(parseInt(SessionAlertTimeout) * 1000 * 60);
    timeAlertSessionOut = setTimeout('AlertSessionTimeout()', oneLess);
    window.parent.location.relaod();
}

function confirmCallBackFn(arg) {
    //  TestAlert('Confirmation responded');
    //   TestAlert(arg);
    if (arg != null) {
        if (arg == true) {
            //ContinueSession();
            clearTimeout(timeChangeTitle);
            clearTimeout(timeForceSessionOut);
            //TestAlert('Continue Callback');
            //TestAlert(timeAlertSessionOut);
            //clearTimeout(timeAlertSessionOut);
            methodCalledAtLoad = null;
            EnableFrameTop();
            ContinueCallback();

        }
        else {
            // TestAlert("hello logoutsession: ");
            LogOutSession();
        }
    }
    else {
        // TestAlert('Unexpected at all');
        LogOutSession();
    }
}

function ContinueCallback() {
    var ajaxManager = $find('aspLogoutMgr');
    //TestAlert('Ajax request made');
    ajaxManager.ajaxRequest('');
}

function ChangeTitle() {

    //    var pnlSignOut = document.getElementById('pnlLogOut'); 
    //    if(pnlSignOut.style.display == 'block')
    //    {
    if (Sys.Browser.agent == Sys.Browser.InternetExplorer) {
        setTimeout("window.parent.focus();", 5000);
    }
    else if (Sys.Browser.agent == Sys.Browser.Firefox) {
        //window.parent.moveBy(10,-10);
        setTimeout("window.parent.moveBy(10,-10);", 5000);
    }
    else {
        //window.parent.resizeTo(window.screen.availWidth, window.screen.availHeight);
        setTimeout("window.parent.focus();", 5000);
    }


    //        if(window.parent.document.title == 'Lecorpio Application needs your attention')
    //        {
    //            window.parent.document.title = 'Lecorpio IAM Solution Suite';
    //        }
    //        else
    //        { 
    //            window.parent.document.title = 'Lecorpio Application needs your attention';  
    //        }
    //        setTimeout('ChangeTitle()', (1000));
    // }

}

function ForceSessionOut() {

    var fullUrlLogOut = window.location.href;
    var iIndexLogOut = fullUrlLogOut.indexOf('/Runtime');
    var appURLLogOut = null;
    if (iIndexLogOut != -1) {
        appURLLogOut = fullUrlLogOut.substr(iIndexLogOut, (fullUrlLogOut.length - iIndexLogOut));
    }
    appURLLogOut = '..' + appURLLogOut;
    if (needToConfirm) {
        var evaluationResult = EvaluateChanges();
        if (!evaluationResult || document.form1.txtChangedInPriorPostback.value == "true") {

            try {
                for (var j = 0; j < Page_Validators.length; j++) {
                    ValidatorEnable(Page_Validators[j], false); //Disable all the validators for required fields only before disabling them
                }
            }
            catch (e) {
            }
            document.form1.txtFullUrl.value = appURLLogOut;
            document.form1.txtSubmitForm.value = "Submit";
            window.status = "Please wait while the next page loads.";
            needToConfirm = false;
            __doPostBack('', '@@@@@:LogOutPage');
        }
        else {
            needToConfirm = false;
            //window.location.href = "../SignedOut.aspx?ForcedLogout=true";
            window.parent.location.href = "Default.aspx?Logoff=true";
        }
    }
    else {
        needToConfirm = false;
        //window.location.href = "../SignedOut.aspx?ForcedLogout=true";
        window.parent.location.href = "Default.aspx?Logoff=true";
    }

    return false;
}

function ContinueSession() {
    if (!ValidateXss()) {
        return false;
    }
    needToConfirm = false;
    try {

        for (var j = 0; j < Page_Validators.length; j++) {

            ValidatorEnable(Page_Validators[j], false); //disable all the validators for required fields only before disabling them
        }
    }
    catch (e) {
    }
    window.parent.document.title = 'Lecorpio IAM Solution Suite';
    var fullUrl = window.location.href;
    var iIndex = fullUrl.indexOf('/Runtime');
    var appURL = null;
    if (iIndex != -1) {
        appURL = fullUrl.substr(iIndex, (fullUrl.length - iIndex));
    }
    appURL = '..' + appURL;
    document.form1.txtSubmitForm.value = "Submit";
    document.form1.txtFullUrl.value = appURL;
    window.status = "Please wait while the next page loads.";
    __doPostBack('', '');
    return false;
}

var timeAlertSessionOut = null;
var timeSessionOut = null;
var methodCalledAtLoad = null;
function SessionMessage(timeOutValue) {
    // TestAlert('methodCalledAtLoad ' + methodCalledAtLoad);
    if (methodCalledAtLoad) {
        // methodCalledAtLoad = null;
        return;
    }

    methodCalledAtLoad = true;
    // TestAlert('methodCalledAtLoad ' + methodCalledAtLoad);

    //TestAlert(timeOutValue);
    timeSessionOut = timeOutValue;
    // TestAlert(window.location + " causing timer ticking 1! with: " + timeOutValue)

    //var oneLess = parseInt(parseInt(timeOutValue) * 1000 * 60) - 60000;
    var oneLess = parseInt(parseInt(timeOutValue) * 1000 * 60) - parseInt(parseInt(SessionAlertTimeout) * 1000 * 60);
    timeAlertSessionOut = setTimeout('AlertSessionTimeout()', oneLess);
}

function BypassRadValidation(timeOutValue) {
    //  alert(window.location + " causing timer ticking2! with: " + timeOutValue)
    var oneminLess = parseInt(parseInt(timeOutValue) * 1000 * 60) - 75000;
    setTimeout('BypassRadCheck()', oneminLess);
}

function BypassRadCheck() {
    needToConfirm = false;
    try {

        for (var j = 0; j < Page_Validators.length; j++) {
            ValidatorEnable(Page_Validators[j], false); //disable all the validators for required fields only before disabling them
        }
    }
    catch (e) {
    }
    return false;
}

function RadPanelBarLoaded(sender) {
    var pr1;
    pr1 = sender;
    var strPanelID = pr1.get_id();
    var strPanel = $find(strPanelID);
    var strPanelItems = null;
    if (strPanel != null) {
        strPanelItems = strPanel.get_items();
        //        strPanelItems.getItem(0).focus();
    }
    if (strPanelItems.getItem(0).get_expanded() == true) {
        strPanelItems.getItem(0).set_expanded(false);
        strPanelItems.getItem(0).set_expanded(true);
    }
    else {
        strPanelItems.getItem(0).set_expanded(true);
        strPanelItems.getItem(0).set_expanded(false);
    }
}

function Gettime() {
    Lecorpio.Application.IAM.UIWebService.Gettime(SucceededCallback, FailedCallback);
}

function SucceededCallback(result, eventArgs) {

    document.getElementById("panel").innerHTML = result;
}

function FailedCallback(error) {
    var stackTrace = error.get_stackTrace();
    var message = error.get_message();
    var statusCode = error.get_statusCode();
    var exceptionType = error.get_exceptionType();
    var timedout = error.get_timedOut();

    // Display the error.    
    document.getElementById("panel").innerHTML =
    "Stack Trace: " + stackTrace + "<br/>" +
    "Service Error: " + message + "<br/>" +
    "Status Code: " + statusCode + "<br/>" +
    "Exception Type: " + exceptionType + "<br/>" +
    "Timedout: " + timedout;
}

function MyAlert(message, level) {
    if (level >= alertLevel) {
        //alert(message);
    }
}

//functions for controlling the popups
var processETTFCommandsOnLoad = false;
var processETTFCommandsOnSave = false;
var processETTFCommandsOnAnalyticalChartingDashboardCall = false; /*added on 23 July, 2009 to enable Analytical Charting Dashboard to invoke TDC Level ETWF events */

function SelectReferencedObjectForMobile(primaryFieldId, processFormula, priority, affectedParentsCSV, ctl) {
    $.mobile.ajaxEnabled = true;
    for (i = 0; i < referencedFieldsArray.length; i++) {
        if (referencedFieldsArray[i][0] == primaryFieldId) {
            //return ShowObjectLookupWindow(primaryFieldId, referencedFieldsArray[i][2], referencedFieldsArray[i][3], processFormula, priority, affectedParentsCSV);
            $(ctl).attr("href", "../Mobile/MobileObjectLookup.aspx?FieldType=" + referencedFieldsArray[i][2] +
				"&StructureId=" + referencedFieldsArray[i][3] +
				"&FieldId=" + primaryFieldId +
				"&ProcessFormula=" + processFormula +
				"&Priority=" + priority +
				"&AffectedParentsCSV=" + affectedParentsCSV);
        }
    }
    return false; //should not reach here but just in case
}


function SelectReferencedObject(primaryFieldId, processFormula, priority, affectedParentsCSV) {
    if (typeof (IsMobile) != "undefined" && IsMobile == true)
        return;
    for (i = 0; i < referencedFieldsArray.length; i++) {
        if (referencedFieldsArray[i][0] == primaryFieldId) {
            return ShowObjectLookupWindow(primaryFieldId, referencedFieldsArray[i][2], referencedFieldsArray[i][3], processFormula, priority, affectedParentsCSV);
        }
    }
    return false; //should not reach here but just in case
}

//function SelectReferencedObject(sFieldType, sStructureId, sControlIdForObjectId, sControlIdForPrimaryFieldData, sControlIdsForPrimaryFieldsData, sFieldIdsForPrimaryFieldsData)
function ShowObjectLookupWindow(primaryFieldId, fieldType, structureId, processFormula, priority, affectedParentsCSV) {
    win.setSize("700px", "540px");
    //win.offsetX = 50;
    //win.offsetY = -400;
    //win.returnFunctionForClient = ;
    var url = "ObjectLookup.aspx?FieldType=" + fieldType +
				"&StructureId=" + structureId +
				"&FieldId=" + primaryFieldId +
				"&ProcessFormula=" + processFormula +
				"&Priority=" + priority +
				"&AffectedParentsCSV=" + affectedParentsCSV;
    win.setUrl(url);
    win.showPopupNoAnchor(150, 70, "window_ObjectLookup");
    return false;
}

function ShowBookmarkHash(strBookHashURL) {

    var strPanelID = null;
    var hdnBookmark = $get('hdnBookmarkGrid');
    if (parseInt(strBookHashURL.indexOf('$')) == -1) {
        strPanelID = strBookHashURL.substr(0, strBookHashURL.indexOf('_'));
    }
    else {
        strPanelID = strBookHashURL.substr(0, strBookHashURL.indexOf('$'));
    }
    var strPanel = $find(strPanelID);
    var strPanelItems = null;
    if (strPanel != null) {
        strPanelItems = strPanel.get_items();
        //strPanelItems.getItem(0).focus();
    }
    //strBookHashURL = strBookHashURL.ReplaceAll('_','$');
    if (strPanelItems != null) {
        strPanelItems.getItem(0).set_expanded(false);
        strPanelItems.getItem(0).set_expanded(true);
        strPanelItems.getItem(0).expand(true);
        hdnBookmark.value = strBookHashURL;
        setTimeout("RadFocus('" + strBookHashURL + "')", 1000);
    }
    else {
        //        var browserName = navigator.userAgent.toLowerCase();
        //        var iBrowser = browserName.indexOf("safari");
        //        if(iBrowser != -1)
        //        {
        //            var chkDelete = strBookHashURL.indexOf('btnDelete');
        //            if(chkDelete == -1)
        //            {
        //                var gridID = strBookHashURL.substr(0, strBookHashURL.indexOf('_'));
        //                gridID = gridID + 'xiamGrid1xinnerGrid';
        //                var gridControl = igtbl_getGridById(gridID);
        //                var iLenRow = gridControl.Rows.length;
        //                if(iLenRow > 0)
        //                {
        //                    var iLenColumn = gridControl.Bands[0].Columns.length;
        //                    var gridRowRecords = new Array();
        //                    for(var iRows = 0;iRows < iLenRow;iRows++)
        //                    {
        //                        var columnRecord = '';
        //                        for(var iColumn = 0;iColumn < iLenColumn; iColumn++)
        //                        {
        //                            if(iColumn == 0)
        //                            {
        //                                if(gridControl.Rows.getRow(iRows).getCell(iColumn).getValue() != null)
        //                                {
        //                                    columnRecord = gridControl.Rows.getRow(iRows).getCell(iColumn).getValue();
        //                                }
        //                                else
        //                                {
        //                                    columnRecord = '';
        //                                } 
        //                            }
        //                            else
        //                            {
        //                                if(gridControl.Rows.getRow(iRows).getCell(iColumn).getValue() != null)
        //                                {
        //                                    columnRecord = columnRecord + '%%%%%%' + gridControl.Rows.getRow(iRows).getCell(iColumn).getValue();
        //                                }
        //                                else
        //                                {
        //                                    columnRecord = columnRecord + '%%%%%%' + '';
        //                                }
        //                            }
        //                        }
        //                        gridRowRecords[iRows] = columnRecord;
        //                    }
        //                    gridControl.AllowDelete=1;
        //                    var iRowDelete;
        ////alert('fix works for deleting all rows: '+iLenRow+'  For:'+strBookHashURL);
        //                    for(iRowDelete = 0; iRowDelete < iLenRow; iRowDelete++)
        //                    {
        //                        igtbl_deleteRow(gridID,gridID + '_r_' + iRowDelete);
        //                    }
        //                    
        //                    var gridRow = null;
        ////alert('fix works for adding with rows: '+iLenRow);
        //                    for (var iRowAdded=0; iRowAdded < iLenRow; iRowAdded++)
        //                    {
        //                        gridRow = igtbl_addNew(gridID, 0);
        //                        var dataRow = gridRowRecords[iRowAdded];
        //                        var columnRow = dataRow.split('%%%%%%');
        //                     
        //                        for(var iColumnAdded = 0;iColumnAdded < iLenColumn; iColumnAdded++)
        //                        {
        //                            var iStart = columnRow[iColumnAdded].toLowerCase().indexOf("<a");
        //                            var iEnd = columnRow[iColumnAdded].toLowerCase().indexOf("</a>");
        //                            var iLength = columnRow[iColumnAdded].length;
        //                            if(iStart == 0 && (iEnd == (iLength - 4)))
        //                            {
        //                                gridRow.getCell(iColumnAdded).getElement().innerHTML = columnRow[iColumnAdded];
        //                            }
        //                            else
        //                            {
        //                                gridRow.getCell(iColumnAdded).setValue(columnRow[iColumnAdded]); 
        //                            }
        //                        }
        //                    }
        //                }
        //            }else
        //            {
        //           // alert('delete call');
        //            }
        //     }

        hdnBookmark.value = strBookHashURL;
        window.location.href = window.location.href + '#' + strBookHashURL;

    }

    try {
        //handling safari 4.0.4 bug --on 5 feb 2010
        var browserName = navigator.userAgent.toLowerCase();
        var iBrowser = browserName.indexOf("safari");

        if (iBrowser = -1) {

            // alert('safari bug');       //commented on --21 Dec., 2010
            // PersistingViewStateForSafari();   //commented on --21 Dec., 2010
            // alert('safari bug');

        }
    } catch (ex) {
        alert(ex);
    }

}




function IsSafari() {
    try {
        //handling safari 4.0.4 bug --on 5 feb 2010
        var browserName = navigator.userAgent.toLowerCase();
        var iBrowser = browserName.indexOf("safari");
        if (iBrowser != -1) {
            return true;
        } else {
            return false;
        }
    } catch (ex) {
        //alert(ex);
    }



}




function RadFocus(strBookURL) {
    window.location.href = window.location.href + '#' + strBookURL;
    return false;
}

function ShowSearchWindow(searchURL, strHeight, strWidth, strHash) {
    // TFS-1064 LPD-410 File History Action dialog should have title--edited Hridya Nambissan
    var id = document.getElementById(strHash);
    //Solved LPD-477:- Add object undefined condition
    var title = "";
    if (id != undefined) {
        id = id.id;
        var lblTitle = id.replace("_btnAddNew", "_lblTitle");
        var lblTitleId = document.getElementById(lblTitle);
        title = lblTitleId.innerHTML;
    }

    if (document.form1.txtDataMode.value == 'Add') {
        //alert('prompts here so fix here');
        var chkValue = PromptDataEntryInAddMode();

        if (chkValue == false) {
            return false;
        }
        else {
            return true;
        }
    }


    var evaluationResult = true;
    var txt = null;
    try {
        txt = monitorChangesValues;
        evaluationResult = EvaluateChanges();
    }
    catch (Err) {
        evaluationResult = true;
    }
    if (evaluationResult == false) {
        needToConfirm = false;
        return true;
    }
    else {
        needToConfirm = false;
    }

    var iIndex = searchURL.indexOf("?TypeId=00000000-0000-0000-0000-000000000000");
    var iButton = strHash.indexOf("btn");
    var strURL = null;
    var iRelatedIndex = searchURL.indexOf("RelatedTypeId=00000000-0000-0000-0000-000000000000");
    if (iIndex != -1) {
        try {
            var strDDLFirst = strHash.substr(0, iButton);
            var strDDL = strDDLFirst + 'ddlEntityTypes';
            var ctrlDDL = $get(strDDL);
            // alert(ctrlDDL);
            var strFirst = searchURL.substr(0, parseInt(iIndex));
            var strLast = searchURL.substr((parseInt(iIndex) + 45), (parseInt(searchURL.length) - parseInt(iIndex) - 45));
            searchURL = strFirst + '?TypeId=' + ctrlDDL.options[ctrlDDL.selectedIndex].value + '&' + strLast;
        }
        catch (ea) {
        }

        var iError = searchURL.indexOf("?TypeId=&");
        if (iError == -1) {

            var oWnd = radopen(searchURL, "RWObjectEntity"); //"RWObjectEntity"
            //            oWnd.OnClientClose = function () {
            //                oWnd = null;
            //            }
            //Bug Resolved-470 Setting Radwindow object null
            oWnd.add_close(function (sender, eventArgs) {
                oWnd.SetTitle("");
                oWnd = null;
            });
            var iHeight = parseInt(strHeight);
            var iWidth = parseInt(strWidth);
            oWnd.setSize(iWidth, iHeight);
            oWnd.center();
            //            oWnd.position(0, 0);
            //            oWnd.setActive()
            //            oWnd.show();
        }
        else {
            return true;
        }
    }
    else {
        if (iRelatedIndex != -1) {
            var strDDLFirst = strHash.substr(0, iButton);
            try {
                var strDDL = strDDLFirst + 'ddlEntityTypes';
                var ctrlDDL = $get(strDDL);
                var strFirst = searchURL.substr(0, parseInt(iRelatedIndex));
                var strLast = searchURL.substr((parseInt(iRelatedIndex) + 51), (parseInt(searchURL.length) - parseInt(iRelatedIndex) - 51));
                searchURL = strFirst + 'RelatedTypeId=' + ctrlDDL.options[ctrlDDL.selectedIndex].value + '&' + strLast;
            }
            catch (e) {
                var iIndexHeader = searchURL.indexOf("&ShowTypeHeaders=True");
                searchURL = searchURL.substr(0, iIndexHeader) + '&ShowTypeHeaders=False' + searchURL.substr((iIndexHeader + 21), (searchURL.length - iIndexHeader - 21));

            }
            var iRelatedError = searchURL.indexOf("RelatedTypeId=&");
            if (iRelatedError == -1) {

                var oWnd = radopen(searchURL, "RWObjectEntity") //"RWObjectEntity"
                //Bug Resolved-470 Setting Radwindow object null
                oWnd.add_close(function (sender, eventArgs) {
                    oWnd.SetTitle("");
                    oWnd = null;
                });
                //                oWnd.OnClientClose = function () {
                //                    oWnd = null;
                //                }
                var iHeight = parseInt(strHeight);
                var iWidth = parseInt(strWidth);
                oWnd.setSize(iWidth, iHeight);
                oWnd.center();
                //                oWnd.position(0, 0);
                //                oWnd.setActive()
                //                oWnd.show();
            }
            else {
                return true;
            }
        }
        else {

            var oWnd = radopen(searchURL, "RWObjectEntity"); //"RWObjectEntity"            
            //Bug Resolved-470 Setting Radwindow object null
            oWnd.add_close(function (sender, eventArgs) {
                oWnd.SetTitle("");
                oWnd = null;
            });
            var iHeight = parseInt(strHeight);
            var iWidth = parseInt(strWidth);
            oWnd.SetTitle(title); //TFS-1064 LPD-410 File History Action dialog should have title--edited Hridya Nambissan
            oWnd.setSize(iWidth, iHeight);
            oWnd.center();
            //oWnd.position(0, 0);
            //oWnd.setActive()
            //oWnd.show();
        }
    }


    return false;
}

function AfterCellUpdateHandlerRelations(gridName, rowId) {
    //alert("comes here");
    var relationsGrid = igtbl_getGridById(gridName);
    var showDeleteButton = false;
    //alert(gridName);
    var ucName = new String(gridName.substr(0, gridName.indexOf("xiamGrid1xinnerGrid")));
    //alert(ucName);

    //fixing safari 4.0.4 bugs

    var strObjectIds = '';
    var hdnRowsToBeDeleted = null;
    var RaducName = null;
    if (IsSafari()) {
        if (ucName.substr(0, 11) == 'RadPanelBar') {
            RaducName = ucName.replace('xi0xi0x', '_i0_i0_');
        }
        else {
            RaducName = ucName;
        }

        hdnRowsToBeDeleted = document.getElementById(RaducName + '_hdnRowsToBeDeleted');
        if (hdnRowsToBeDeleted != null)
            hdnRowsToBeDeleted.value = '';
    }
    //fixing safari 4.0.4 bugs  --ends here
    //alert(ucName);
    //alert(relationsGrid.Rows.length);
    for (var rowIndex = 0; rowIndex < relationsGrid.Rows.length; rowIndex++) {
        //alert(rowIndex);
        //alert(relationsGrid.Rows.getRow(rowIndex).DataKey);
        //alert(relationsGrid.Rows.getRow(rowIndex).getCellFromKey("Delete").getValue());


        if (relationsGrid.Rows.getRow(rowIndex).getCellFromKey("Delete").getValue() == "true") {
            //alert('found one row');
            showDeleteButton = true;

            //fixing safari 4.0.4 bugs
            if (IsSafari())
                strObjectIds += relationsGrid.Rows.getRow(rowIndex).getCellFromKey("ObjectId").getValue() + ",";
            //fixing safari 4.0.4 bugs -- ends here
            //break;
        }
    }
    //fixing safari 4.0.4 bugs
    if (IsSafari()) {
        if (hdnRowsToBeDeleted != null)
            hdnRowsToBeDeleted.value = strObjectIds;
        //alert(strObjectIds);
    }
    //fixing safari 4.0.4 bugs --ends here

    if (ucName.substr(0, 11) == 'RadPanelBar') {
        ucName = ucName.replace('xi0xi0x', '_i0_i0_');
        if (document.form1.elements[ucName + "_btnDelete"] != null) {
            document.form1.elements[ucName + "_btnDelete"].disabled = !showDeleteButton;
        }
    }
    else {
        if (document.form1.elements[ucName + "_btnDelete"] != null) {
            document.form1.elements[ucName + "_btnDelete"].disabled = !showDeleteButton;
        }
    }
}

function AfterCellUpdateHandlerHierarchy(gridName, rowId) {
    //alert("comes here");
    //alert(gridName);
    //alert(grid.substr(0, gridName.indexOf("xiamGrid1xinnerGrid")));
    var grid = igtbl_getGridById(gridName);
    //alert(gridName.substr(0, gridName.indexOf("xiamGrid1xinnerGrid")));
    var showDeleteButton = false;
    var ucName = new String(gridName.substr(0, gridName.indexOf("xiamGrid1xinnerGrid")));
    var strObjectIds = '';
    var hdnRowsToBeDeleted = null;
    var RaducName = null;
    if (IsSafari()) {
        if (ucName.substr(0, 11) == 'RadPanelBar') {
            RaducName = ucName.replace('xi0xi0x', '_i0_i0_');
        }
        else {
            RaducName = ucName;
        }
        hdnRowsToBeDeleted = document.getElementById(RaducName + '_hdnRowsToBeDeleted');
        if (hdnRowsToBeDeleted != null)
            hdnRowsToBeDeleted.value = '';
    }
    //alert(ucName);
    //alert(grid.Rows.length);
    for (var rowIndex = 0; rowIndex < grid.Rows.length; rowIndex++) {
        //alert(rowIndex);
        //alert(relationsGrid.Rows.getRow(rowIndex).DataKey);
        //alert(relationsGrid.Rows.getRow(rowIndex).getCellFromKey("Delete").getValue());
        if (grid.Rows.getRow(rowIndex).getCellFromKey("Delete").getValue() == "true") {
            //alert('found one row');
            showDeleteButton = true;
            if (IsSafari()) {
                strObjectIds += grid.Rows.getRow(rowIndex).getCellFromKey("ObjectId").getValue() + "~" + grid.Rows.getRow(rowIndex).getCellFromKey("TypeId").getValue() + "~" + grid.Rows.getRow(rowIndex).getCell(1).getValue() + ",";
            }
            //strObjectIds+=relationsGrid.Rows.getRow(rowIndex).getCellFromKey("ObjectId").getValue()+",";
            //break;
        }
    }
    if (IsSafari()) {
        if (hdnRowsToBeDeleted != null)
            hdnRowsToBeDeleted.value = strObjectIds;
    }
    //alert(showDeleteButton);
    if (ucName.substr(0, 11) == 'RadPanelBar') {
        ucName = ucName.replace('xi0xi0x', '_i0_i0_');
        if (document.form1.elements[ucName + "_btnDelete"] != null) {
            document.form1.elements[ucName + "_btnDelete"].disabled = !showDeleteButton;
        }
    }
    else {
        if (document.form1.elements[ucName + "_btnDelete"] != null) {
            document.form1.elements[ucName + "_btnDelete"].disabled = !showDeleteButton;
        }
    }
}
function DelayForPanel() {
}
function ProcessETTFCommands() {
    if (processETTFCommandsOnLoad) {
        ProcessETTFCommandsOnLoad();

    }
    if (processETTFCommandsOnSave) {
        ProcessETTFCommandsOnSave();
    }
    /*added on 23 July, 2009 to enable Analytical Charting Dashboard to invoke TDC Level ETWF events */
    if (processETTFCommandsOnAnalyticalChartingDashboardCall) {
        ProcessETTFCommandsOnAnalyticalChartingDashboardCall();
    }
}

//commented on 11 sep, 2000 to generate auto forms

//function DisplayMergeDocument(htmlFragment, inNewWindow)
//	var urlToNavigate = "ShowMergeDocument.aspx?htmlFragment="+htmlFragment;
//	if(inNewWindow)
//	{
//		window.open(urlToNavigate, "", "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width="+window.screen.availWidth+",height="+window.screen.availHeight);
//	}
//	else
//	{
//		//alert("same window"+urlToNavigate)
//		//window.parent.navigate(urlToNavigate); this opens in the full window
//		window.navigate(urlToNavigate);
//	}
//}
var count, url1, url2, url3;
function DisplayMergeDocument(count, url1, url2, url3, inNewWindow) {
    if (count > 0) {
        if (count == 1) {
            win = window.open(url1, "Window1", "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width=" + window.screen.availWidth + ",height=" + window.screen.availHeight);
        }
        if (count == 2) {
            win = window.open(url2, "Window2", "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width=" + window.screen.availWidth + ",height=" + window.screen.availHeight);
        }
        if (count == 3) {
            win = window.open(url3, "Window3", "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width=" + window.screen.availWidth + ",height=" + window.screen.availHeight);
        }
        if (count == 4) {
            /* //changed on 10 aug, 2009 to avoid errors when url has resereved characters like space etc. that actually need to be encoded */
            url1 = EscapeUrl(url1);
            url2 = EscapeUrl(url2);
            url3 = EscapeUrl(url3);
            //alert(url1);
            win1 = window.open("", "Window1", "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width=" + 0.5 * (window.screen.availWidth) + ",height=" + 0.5 * (window.screen.availHeight));
            win1.document.write('<img  alt=hello src=../Images/logo.gif align=top />');
            win1.document.write('<p align=center><h3 align=center>Click the link below to view the document:<h3><br><br>');
            win1.document.write('<p align=center><a target=_blank href=' + url1 + '>' + "HTML Document" + '</a><br><br>');
            win1.document.write('<a target=_blank href=' + url2 + '>' + "PDF Document" + '</a><br><br>');
            win1.document.write('<a target=_blank href=' + url3 + '>' + "RTF Document" + '</a>');
        }
    }

}
//added on 10 aug, 2009
function EscapeUrl(url) {
    var position = url.indexOf(':');
    if (position > -1) {
        var LeftUrl = url.substring(position + 3);
        var protocal = url.substring(0, position);
        url = protocal + "://" + escape(LeftUrl);
    }
    return url;

}


//always in a new window --called via the ETWF commands
function DisplayTypeDisplayContext(typeDisplayContextId, dataMode, width, height) {
    DisplayTypeDisplayContextWithSizeInfo(document.form1.txtTypeId.value, typeDisplayContextId, true, dataMode, width, height);
}

//#region Start Preview Email :27 August 2010
function DisplayEmailPreview(typeId, objectId, emailRouteId, width, height, eventId, actionId, typeDisplayContextId, ConditionTextWithoutTags) {
    width = 780;
    height = 400;
    if (width == 0) {
        width = window.screen.availWidth;
    }
    if (height == 0) {
        height = window.screen.availHeight - 30;
    }
    var url = "EmailPreview.aspx?TypeId=" + typeId +
						"&ObjectId=" + objectId +
                        "&EventId=" + eventId +
                        "&ActionId=" + actionId +
                        "&TDCId=" + typeDisplayContextId +
                        "&CTWT=" + ConditionTextWithoutTags +
						"&EmailRouteId=" + emailRouteId;

    //window.open(url, "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width=" + width + ",height=" + height);

    //alert(url);
    var oWnd1 = radopen(url, null);
    //    var iHeight = parseInt(320);
    //    var iWidth = parseInt(600);
    //alert(oWnd1);


    var iLeft = parseInt(window.screen.availWidth) / 2;
    var iTop = parseInt(window.screen.availHeight - 60) / 2;
    iLeft = parseInt(iLeft) - parseInt(250);
    iTop = parseInt(iTop) - parseInt(300);
    oWnd1.moveTo(iLeft, iTop);
    oWnd1.setSize(width, height);
    oWnd1.center();
    oWnd1.set_modal(true);
    //oWnd1.show();
    //alert(url);

    return false;
    //window.open(GetURL(typeId, typeDisplayContextId, useObjectId, dataMode), "", "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width=" + width + ",height=" + height);
}

//#endregion Start Preview Email :27 August 2010


//#region Start Compare XMl : 01282011
function DisplayMapDetail(typeId, objectId, CompareXMLId, width, height, eventId, actionId, typeDisplayContextId) {
    width = 780;
    height = 400;
    if (width == 0) {
        width = window.screen.availWidth;
    }
    if (height == 0) {
        height = window.screen.availHeight - 30;
    }
    var url = "UpdateData.aspx?TypeId=" + typeId +
						"&ObjectId=" + objectId +
                        "&EventId=" + eventId +
                        "&ActionId=" + actionId +
                        "&TDCId=" + typeDisplayContextId +
                        "&CompareXMLId=" + CompareXMLId;

    var oWnd1 = radopen(url, null);

    var iLeft = parseInt(window.screen.availWidth) / 2;
    var iTop = parseInt(window.screen.availHeight - 60) / 2;
    iLeft = parseInt(iLeft) - parseInt(250);
    iTop = parseInt(iTop) - parseInt(300);
    oWnd1.moveTo(iLeft, iTop);
    oWnd1.setSize(width, height);
    oWnd1.center();
    oWnd1.set_modal(true);
    oWnd1.maximize();
    return false;
}

//#endregion Start Compare XMl : 01282011



//always in a new window --called via the TypeDisplayContextLink or TypeDisplayContextTab
function DisplayTypeDisplayContextWithSizeInfo(typeId, typeDisplayContextId, useObjectId, dataMode, width, height) {
    if (width == 0) {
        width = window.screen.availWidth;
    }
    if (height == 0) {
        height = window.screen.availHeight;
    }

    window.open(GetURL(typeId, typeDisplayContextId, useObjectId, dataMode), "", "channelmode=no,directories=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,status=yes,titlebar=yes,toolbar=yes,top=0,left=0,width=" + width + ",height=" + height);
}

function GetURL(typeId, typeDisplayContextId, useObjectId, dataMode) {
    var urlToNavigate;
    if (useObjectId) {
        urlToNavigate = "EntityObject.aspx?TypeId=" + typeId +
						"&ObjectId=" + document.form1.txtObjectId.value +
						"&TypeDisplayContextId=" + typeDisplayContextId +
						"&DataMode=" + dataMode;
    }
    else {
        urlToNavigate = "EntityObject.aspx?TypeId=" + typeId +
						"&TypeDisplayContextId=" + typeDisplayContextId +
						"&DataMode=" + dataMode;
    }
    return urlToNavigate;
}

function ProcessDropdown(e) {
    //alert("ProcessDropdown");
    var target = e.target ? e.target : e.srcElement;

    var fieldId = target.id.substr("field".length, 36);
    try {
        window.document.form1.elements["field" + fieldId + "_PK"].value = window.document.form1.elements["field" + fieldId].value;
    }
    catch (e) {
        var element = null;
        fieldId = target.id.substr(target.id.indexOf("field"), 41);
        for (var iFind = 0; iFind < window.document.form1.elements.length; iFind++) {
            element = window.document.form1.elements[iFind];
            if (element.id.indexOf(fieldId + "_PK") != -1) {
                break;
            }

        }

        var elementID = element.id;
        var eText = elementID.substr(0, elementID.length - 3);
        window.document.form1.elements[elementID].value = window.document.form1.elements[eText].value;
    }
}
function ProcessDropdownWithAddNew(e, primaryFieldId, AffectedParentCSV) {
    //alert("ProcessDropdown");
    var target = e.target ? e.target : e.srcElement;

    var fieldId = target.id.substr("field".length, 36);

    try {
        //alert(window.document.form1.elements["field" + fieldId].value);
        if (window.document.form1 != null) {
            if (window.document.form1.elements["field" + fieldId].value == "<Add New>") {
                window.document.form1.elements["field" + fieldId][0].selected = "1";
                this.SelectReferencedObjectWithAddNew(primaryFieldId, true, -1, AffectedParentCSV);
            }
            else {
                window.document.form1.elements["field" + fieldId + "_PK"].value = window.document.form1.elements["field" + fieldId].value;
            }
        }
        else {
            if ($(target).val() == "<Add New>") {
                // window.document.form1.elements["field" + fieldId][0].selected = "1";
                this.SelectReferencedObjectWithAddNew(primaryFieldId, true, -1, AffectedParentCSV);
            }
            else {
                $("#" + $(target).attr('id') + "_PK").val($(target).val());
            }
        }

    }
    catch (e) {
        var element = null;
        fieldId = target.id.substr(target.id.indexOf("field"), 41);
        for (var iFind = 0; iFind < window.document.form1.elements.length; iFind++) {
            element = window.document.form1.elements[iFind];
            if (element.id.indexOf(fieldId + "_PK") != -1) {
                break;
            }

        }

        var elementID = element.id;
        var eText = elementID.substr(0, elementID.length - 3);
        //alert(window.document.form1.elements[eText].value);

        if (window.document.form1.elements[eText].value == "<Add New>") {
            window.document.form1.elements[eText][0].selected = "1";
            this.SelectReferencedObjectWithAddNew(primaryFieldId, true, -1, AffectedParentCSV);

            //window.document.form1.elements[elementID].value = window.document.form1.elements[eText].value;
        }
        else {
            window.document.form1.elements[elementID].value = window.document.form1.elements[eText].value;
        }
    }
}
function SelectReferencedObjectWithAddNew(primaryFieldId, processFormula, priority, affectedParentsCSV) {
    for (i = 0; i < referencedFieldsArray.length; i++) {
        if (referencedFieldsArray[i][0] == primaryFieldId) {
            return ShowObjectLookupWindowWithAddNew(primaryFieldId, referencedFieldsArray[i][2], referencedFieldsArray[i][3], processFormula, priority, affectedParentsCSV, 'Add');
        }
    }
    return false; //should not reach here but just in case
}
function ShowObjectLookupWindowWithAddNew(primaryFieldId, fieldType, structureId, processFormula, priority, affectedParentsCSV, mode) {

    win.setSize("700px", "540px");
    //win.offsetX = 50;
    //win.offsetY = -400;
    //win.returnFunctionForClient = ;
    var url = "ObjectLookup.aspx?FieldType=" + fieldType +
				"&StructureId=" + structureId +
				"&FieldId=" + primaryFieldId +
				"&ProcessFormula=" + processFormula +
				"&Priority=" + priority +
				"&Mode=" + mode +
				"&AffectedParentsCSV=" + affectedParentsCSV;
    //alert(url);
    win.setUrl(url);
    win.showPopupNoAnchor(150, 70, "window_ObjectLookup");
    return false;
}
function addOption(comboBoxId, text, value) {
    var selObj = document.getElementById(comboBoxId);
    var opt = document.createElement("option");
    var optToAddBefore = selObj.options[selObj.length - 1];

    try {
        selObj.add(opt, optToAddBefore);
        opt.text = text.toString();
        opt.value = value.toString();
        opt.selected = true;
    } catch (e) {
        selObj.add(opt, selObj.length - 1);
        opt.text = text.toString();
        opt.value = value.toString();
        opt.selected = true;
    }
}
function ProcessWebCombo(id) {

    var combo = igcmbo_getComboById(id);
    var grid = combo.getGrid();
    var gridRow;
    for (var rowId in grid.SelectedRows) {
        gridRow = grid.Rows.getRowById(rowId);
        var fieldId = id.substr("field".length, 36); //36 is for length of the guid
        AssignFieldValuesToCaller(gridRow, fieldId, window, false);
        break;
    }
}

function ClearCombo(fieldId) {
    var combo = igcmbo_getComboById("field" + fieldId + "xcombo");
    combo.setDisplayValue('', false);
    ClearReferenceFields(fieldId, window, false);
}

function SetExporting(btnObject) {
    //alert(e);
}

function SaveSilently(fullUrl) {


    if (!ValidateXss()) {
        return false;
    }
    if (needToConfirm) {
        var evaluationResult = EvaluateChanges();
        //alert(evaluationResult);

        if (!evaluationResult || document.form1.txtChangedInPriorPostback.value == 'true') {
            needToConfirm = false; setTimeout('resetFlag()', 750);
            document.form1.txtFullUrl.value = fullUrl;
            document.form1.txtSubmitForm.value = "Submit";
            needToConfirm = false;
            window.status = "Please wait while the next page loads.";
            __doPostBack('', '');
            return false;
        }
    }
    else {
        return true;
    }
}

function ConfirmCloseForDisplayContext(typeDisplayContextId, fullUrl) {

    //alert(fullUrl);

    if (needToConfirm) {
        var evaluationResult = EvaluateChanges();
        //alert(evaluationResult);

        if (!evaluationResult || document.form1.txtChangedInPriorPostback.value == 'true') {
            needToConfirm = false; setTimeout('resetFlag()', 750);
            document.form1.txtFullUrl.value = fullUrl;
            win.setSize("550px", "170px");
            //win.offsetX = 50;
            //win.offsetY = -400;
            var url = "ConfirmDisplayContextNavigation.aspx"
            win.setUrl(url);
            win.showPopupNoAnchor(300, 150, "window_ObjectLookup");
            return false;
        }
    }
    else {
        return true;
    }
}

function BypassValidator(fullUrl) {
    //alert('ConfirmCloseForDisplayContext2-BypassValidator');
    //alert(fullUrl);

    if (!ValidateXss()) {
        return false;
    }
    needToConfirm = false;
    try {

        for (var j = 0; j < Page_Validators.length; j++) {
            ValidatorEnable(Page_Validators[j], false); //enable all the validators for required fields only before disabling them
        }
    }
    catch (e) {
    }
    //document.form1.txtFullUrl.value = fullUrl;
    document.form1.txtSubmitForm.value = "Submit";
    document.form1.txtFullUrl.value = fullUrl;
    window.status = "Please wait while the next page loads.";
    __doPostBack('', '');
    return false;

}
function ConfirmTabChange() {

    //var confirmOutput=confirmClose1();                                                                                    
    //                                                                                        
    //                                                                                        if(confirmOutput.toString() !=''){
    //                                                                                        return confirm(confirmOutput.toString())
    //                                                                                        } 
    //                                                                                        else
    //                                                                                        {
    //                                                                                        return true;
    //                                                                                        }
    //                                                                                        function confirmClose1() {
    //                                                                                            var needToConfirm1 = true;
    //                                                                                            var needToEvaluateChangedInPriorPostback = false;
    //                                                                                            //alert(needToConfirm);
    //                                                                                            if (!needToConfirm1) return '';
    //							                                                                                        var evaluationResult = EvaluateChanges1();
    //							                                                                                        //alert(document.form1.txtChangedInPriorPostback.value);
    //							                                                                                        if (!evaluationResult || document.form1.txtChangedInPriorPostback.value == 'true') {
    //							                                                                                            needToConfirm1 = false; setTimeout('resetFlag()', 750);
    //							                                                                                            return 'You have modified the data entry fields since last savings. If you leave this page, any changes will be lost. To save these changes, click Cancel to return to the page, and then Save the data.';
    //							                                                                                        }
    //							                                                                                        else {
    //							                                                                                            return '';
    //							                                                                                        }
    //			                                                                                        }
    //                                                                                                    function EvaluateChanges1() {
    //			                                                                                            var changeInAutoFilterControl = false;
    //			                                                                                            //alert(monitorChangesValues.length);
    //                                                                                                       
    //			                                                                                            for (var i = 0; i < monitorChangesValues.length; i++) {
    //			                                                                                                var elem = document.getElementById(monitorChangesIDs[i]);
    //			                                                                                                //monitoring change in the autofilter control's value --On 21 Jan 2010
    //			                                                                                                
    //			                                                                                                    // alert(monitorChangesIDs[i]);                        

    //			                                                                                                    // alert(monitorChangesIDs[i].toString().toLowerCase().indexOf('_hdnaf'));
    //			                                                                                                try {
    //			                                                                                                    if (monitorChangesIDs[i].toString().toLowerCase().indexOf('_lcp_hdnaf') > -1) {

    //			                                                                                                        // alert($get(monitorChangesIDs[i].substring(3, monitorChangesIDs[i].length-4)));  //remove suffix '_lcp' from ID the name 
    //			                                                                                                        var CurrentTextList = ReturnItemListOfAutofiltercontrol($get(monitorChangesIDs[i].substring(3, monitorChangesIDs[i].length - ('_lcp_HdnAF'.length))));
    //			                                                                                                        var arrInitialValues = monitorChangesValues[i].trim().split(';.;');
    //			                                                                                                        var arrCurrentTextList = CurrentTextList.trim().split(';.;');
    //			                                                                                                        //alert( arrInitialValues.sort().toString());
    //			                                                                                                        // alert(  arrCurrentTextList.sort().toString());    
    //			                                                                                                        changeInAutoFilterControl = (arrInitialValues.sort().toString().trim() != arrCurrentTextList.sort().toString().trim());

    //			                                                                                                    }
    //			                                                                                                } catch (ex) {

    //			                                                                                                }

    //			                                                                                                if (elem)
    //			                                                                                                    if (((elem.type == 'checkbox' || elem.type == 'radio') && elem.checked != monitorChangesValues[i]) || (elem.type != 'checkbox' && elem.type != 'radio' && elem.value != monitorChangesValues[i]) || (changeInAutoFilterControl)) {
    //			                                                                                                        //alert('changes have been made');
    //			                                                                                                        //alert(needToEvaluateChangedInPriorPostback);
    ////			                                                                                                        if (needToEvaluateChangedInPriorPostback1) {
    ////			                                                                                                            //document.form1.txtChangedInPriorPostback.value = 'true';
    ////			                                                                                                            //alert('text box changed, new value alerted');
    ////			                                                                                                            //alert(document.form1.txtChangedInPriorPostback.value);
    ////			                                                                                                        }
    //			                                                                                                        return false;
    //			                                                                                                    }
    //			                                                                                            }

    //			                                                                                            return true;
    //			                                                                                        }

    //			                                                                                        function resetFlag() { needToConfirm1 = true; }


}
function ConfirmCloseResponse(response) {
    //alert('ConfirmCloseForDisplayContext3');
    switch (response) {
        case "Yes": //save and continue
            //alert("submit the form");
            //submit the form
            if (!ValidateXss()) {
                return false;
            }
            document.form1.txtSubmitForm.value = "Submit";
            needToConfirm = false;
            __doPostBack('', '');
            break;
        case "No": //continue without saving
            //alert("changes discarded and continuing on the display context");
            //alert(document.form1.txtFullUrl.value);
            needToConfirm = false;
            window.navigate(document.form1.txtFullUrl.value);
            //window.Url = document.form1.txtFullUrl.value;
            //submit the form
            break;
        case "Cancel": //stay here
            //alert("staying here");
            //stay here
            break;
    }
}

function PromptDataEntryInAddMode() {


    //alert(document.form1.txtDataMode.value);
    var evaluationResult = EvaluateChanges();
    //alert(evaluationResult +' '+document.form1.txtDataMode.value);

    var hdnIsRecordSaved = $get('hdnIsRecordSaved');

    if (hdnIsRecordSaved != null)//if record is already saved, do not prompt for data entry whether there is no entry made on the page
    {
        if (hdnIsRecordSaved.value == "true")
            evaluationResult = false;
    }

    if (evaluationResult && document.form1.txtDataMode.value == 'Add') {
        var userResponse = confirm("You have not entered/changed any data in the main form.  Are you sure you want to continue?");
        if (userResponse) {
            needToConfirm = false;
        }
        return userResponse;
    } else {

    }

    needToConfirm = false;
    return true;
}

function AssignValueToIntendedPath(uploadControl) {
    //alert(uploadControl.id);
    // alert(uploadControl.value);
    //var intendedPathTextId = uploadControl.id.slice(0, uploadControl.id.indexOf("_file"))+"_txtIntendedPath";
    //alert(intendedPathTextId);
    //document.forms["form1"].elements[intendedPathTextId].value = uploadControl.value;
}

var allEditAdminOjectLinksVisible = true;
function ToggleAllEditAdminObjectLinks() {
    var allLinks = document.form1.getElementsByTagName("a");
    var count = 0;
    var display;
    if (allEditAdminOjectLinksVisible) {
        display = "none";
    }
    else {
        display = "";
    }
    for (var i = 0; i < allLinks.length; i++) {
        var link = allLinks.item(i);
        var customCategory = link.getAttribute("CustomCategory");
        if (customCategory == "EditAdminObject") {
            link.style.display = display;
            count++;
        }
    }
    allEditAdminOjectLinksVisible = !allEditAdminOjectLinksVisible;
    //alert(count);
}

function GetBaseFieldValue(id) {
    var element = document.forms[0].elements[id];
    var result;
    if (element) {
        MyAlert('type of base field' + element.type, 50);
        switch (element.type) {
            case "text":
                //Resolved Bug No 715:Calculation is not performed  in ebilling >Billing Line Items.
                if ((element.value == "" || parseFloat(element.value).toString() == 'NaN') && element.getAttribute('fieldtype') != null && element.getAttribute('fieldtype') != undefined && (element.getAttribute('fieldtype') == 'Decimal' || element.getAttribute('fieldtype') == 'Integer'))
                    result = 0;
                else
                    result = element.value;
                break;
            case "select-one":
                if (isNaN(element.options[element.selectedIndex].value))
                    result = '0';
                else
                    result = element.options[element.selectedIndex].value;
                break;
        }
    }
    else {
        MyAlert('base field is a postback label', 50);
        result = document.getElementById(id).innerHTML;
    }
    return result;
}

function SetFormulaFieldValue(id, value) {
    MyAlert(id, 50);
    MyAlert(value, 50);
    var element = document.forms[0].elements[id];
    if (element) {
        MyAlert('type of formula field' + element.type, 50);
        switch (element.type) {
            case "text":
                element.value = value;
                break;
        }
    }
    else {
        MyAlert('formula field is a postback label', 50);
        var span = document.getElementById(id);
        MyAlert('span found', 50);
        span.innerHTML = value;
        MyAlert('previos value of postback label:' + document.forms[0].elements["__" + id + "_text"].value, 50);
        document.forms[0].elements["__" + id + "_text"].value = value;
        MyAlert('new value of postback label:' + document.forms[0].elements["__" + id + "_text"].value, 50);
    }
}

function UpdateFormulaFieldsFromObjectLookup() {
    UpdateFormulaFields(parseInt(document.form1.txtPriority.value), document.form1.txtAffectedParentsCSV.value);
}

function sayalert() {
    alert("done");
}



function AfterCellUpdateHandlerEditableGrid(gridName, cellId) {
    //alert(gridName+"|"+cellId);
    var cell = igtbl_getCellById(cellId);
    UpdateFormulaFieldsForGrid(cell.Row, cell.Column.Key);
}

function GetBaseFieldValueForGrid(row, columnKey) {
    //alert(row.getCellFromKey(columnKey).getValue());
    return row.getCellFromKey(columnKey).getValue();
}

function SetFormulaFieldValueForGrid(row, columnKey, value) {
    row.getCellFromKey(columnKey).setValue(value);
}

function DisableSeparatorSelection(chartId) {
    var ddlAnalyzeBy = document.form1.elements[chartId + "_ddlAnalyzeBy"];
    //alert(ddlAnalyzeBy[ddlAnalyzeBy.selectedIndex].value);
    if (ddlAnalyzeBy[ddlAnalyzeBy.selectedIndex].value == "") {
        var txtPreviousAnalyzeBySelectedIndex = document.form1.elements[chartId + "_txtPreviousAnalyzeBySelectedIndex"];
        ddlAnalyzeBy.selectedIndex = txtPreviousAnalyzeBySelectedIndex.value;
        return false;
    }
    return true;
}

function ReplaceDoubleQuotes(textbox) {
    // alert(textbox.value);
    var singleQuote = "'";
    textbox.value = textbox.value.replace(/"/g, singleQuote);
}
function IsNumber(_value, fieldname, oButtonId) {

    var specialChar = "<>@!#$%^&*()_+[]{}?:;|'\"\\,/~`-="; //Bug-978: 2.7: Masking: This allows restricted entry of data based on pre-defined masks specified by the administrator-Ishita(18-12-2013)
    for (var i = 0; i < _value.length; i++) {
        if (specialChar.indexOf(_value.charAt(i)) != -1) //if special character there, Pop up will come
        {
            alert('Invalid data entered in ' + fieldname + '. Please enter valid numeric data in ' + fieldname);
            document.forms[0].elements[oButtonId].focus();
            return false;
        }
    }
    if (_value.match(/[a-zA-Z ]/g)) // if alphabets there, Pop up will come
    {
        alert('Invalid data entered in ' + fieldname + '. Please enter valid numeric data in ' + fieldname);
        document.forms[0].elements[oButtonId].focus();
        return false;
    }
    /*var invalidchar = /[^0-9.]/g; // to allow only 0 to 9 digit and dot(.)  //Commented by Ishita as it was allowing letters with digits
    var onlyDigits = /[0-9]/g;
    _value = _value.toString().replace(invalidchar, "");
    if (_value.trim().length == 0) {
    alert('Invalid data entered in ' + fieldname + '. Please enter valid numeric data in ' + fieldname);
    document.forms[0].elements[oButtonId].value = '';
    return false;
    }
    else if ((_value.replace(onlyDigits,"")) == 0) {
    alert('Invalid data entered in ' + fieldname + '. Please enter valid numeric data in ' + fieldname);
    document.forms[0].elements[oButtonId].value = '';     
    return false;
    }*/
    else {
        return true;
    }
}
function SetMasking(textbox, mask, fieldname) {

    var oButtonId = new String(textbox);
    var _value = document.forms[0].elements[oButtonId].value;
    if (_value != '' && mask != 'NoMask' && _value.trim().length > 0) {


        if (mask == '0.00' && IsNumber(_value, fieldname, oButtonId))
            document.forms[0].elements[oButtonId].value = parseFloat(_value).toFixed(2);
        else if (mask == '0.000' && IsNumber(_value, fieldname, oButtonId))
            document.forms[0].elements[oButtonId].value = parseFloat(_value).toFixed(3);
        else if (mask == '0.0' && IsNumber(_value, fieldname, oButtonId))
            document.forms[0].elements[oButtonId].value = parseFloat(_value).toFixed(1);
        else if (mask == '0' && IsNumber(_value, fieldname, oButtonId))
            document.forms[0].elements[oButtonId].value = parseFloat(_value).toFixed(0);
        else if (mask == '#,000.00' && IsNumber(_value, fieldname, oButtonId)) {

            _value = parseFloat(_value).toFixed(2); // if value is enter with dot(.) then it will round upto 2 digit and then mask will apply

            document.forms[0].elements[oButtonId].value = _value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");

        }
        else if (mask == 'p') {
            var invalidchar = /[^0-9.]/g; // to allow only 0 to 9 digit
            _value = _value.toString().replace(invalidchar, "");

            if (_value.trim().length == 0) {
                alert('Invalid data entered in ' + fieldname + '. Please enter valid data in ' + fieldname);
                document.forms[0].elements[oButtonId].value = '';
                return;
            }

            document.forms[0].elements[oButtonId].value = _value.toString() + ' %';
        }
        else if (mask == 'E-mail') {

            var result = _value.split(/,|;/); // for multiple email seperated by comma or semicolon or slash
            for (var i = 0; i < result.length; i++) {
                //  alert(result[i]);
                if (!isEmailAddress(result[i])) {
                    document.forms[0].elements[oButtonId].focus();

                    alert('Invalid data entered in ' + fieldname + '. ' + fieldname + ' must contain @ and dot(.) character');
                    document.forms[0].elements[oButtonId].value = _value.trim().toString();
                    return false;
                }
            }
            document.forms[0].elements[oButtonId].value = _value.trim().toString();
        }
        else if (mask == 'P02') {
            var invalidchar = /[^0-9.]/g; // to allow only 0 to 9 digit
            _value = _value.toString().replace(invalidchar, "");

            if (_value.trim().length == 0) {
                alert('Invalid data entered in ' + fieldname + '. Please enter valid data in ' + fieldname);
                document.forms[0].elements[oButtonId].value = '';

                return;
            }

            document.forms[0].elements[oButtonId].value = parseFloat(_value).toFixed(2).toString() + ' %';
        }
        else if (mask == '000-00-0000' || mask == '{0:###-##-####}') {
            var reSSN = /^(\d{3})[\- ]?(\d{2})[\- ]?(\d{4})$/;
            if (reSSN.test(_value))
                document.forms[0].elements[oButtonId].value = _value.toString().replace(reSSN, "$1-$2-$3");
            else {
                alert('Invalid data entered in ' + fieldname + '. Please enter valid 9 digit ' + fieldname);
                // document.forms[0].elements[oButtonId].value = '';
                document.forms[0].elements[oButtonId].focus();
            }
        }
        else if (mask == '00000-0000') {
            var smallzip = /(^\d{5}$)/; //^(\d{5})[\- ]?(\d{4})$/;
            var longzip = /^(\d{5})[\- ]?(\d{4})$/; //^(\d{5})[\- ]?(\d{4})$/;

            if (_value.length == 5) {
                if (smallzip.test(_value))
                    document.forms[0].elements[oButtonId].value = _value.toString().replace(smallzip, "$1");
                else {
                    alert('Invalid data entered in ' + fieldname + '. Please enter valid 5 or 9 digit ' + fieldname);
                    //  document.forms[0].elements[oButtonId].value = '';
                    document.forms[0].elements[oButtonId].focus();
                }
            }
            else {


                if (longzip.test(_value))
                    document.forms[0].elements[oButtonId].value = _value.toString().replace(longzip, "$1-$2");
                else {
                    //  document.forms[0].elements[oButtonId].value = '';
                    document.forms[0].elements[oButtonId].focus();
                    alert('Invalid data entered in ' + fieldname + '. Please enter valid 5 or 9 digit ' + fieldname);
                }
            }
        }
        else if (mask == '(999)-(999)-(9999)') {

            var invalidchar = /[^0-9]/g; // to allow only 0 to 9 digit
            _value = _value.toString().replace(invalidchar, "");

            var phone = /^(\d{3})[\- ]?(\d{3})[\- ]?(\d{4})$/; ///^\(?(\d{3})\)?[- ]?(\d{3})[- ]?(\d{4})$/;
            if (phone.test(_value))
                document.forms[0].elements[oButtonId].value = _value.toString().replace(phone, "($1)-($2)-($3)");
            else {
                // document.forms[0].elements[oButtonId].value = '';
                document.forms[0].elements[oButtonId].focus();
                alert('Invalid data entered in ' + fieldname + '. Please enter valid 10 digit ' + fieldname);
            }
        }
        else if (mask == '{0: (###) ###-####}') {

            var invalidchar = /[^0-9]/g; // to allow only 0 to 9 digit
            _value = _value.toString().replace(invalidchar, "");


            if (_value.trim().length == 0) {
                alert('Invalid data entered in ' + fieldname + '. Please enter valid data in ' + fieldname);
                document.forms[0].elements[oButtonId].value = '';
                return;
            }


            var cell = /^(\d{3})[\- ]?(\d{3})[\- ]?(\d{4})$/;
            if (cell.test(_value))
                document.forms[0].elements[oButtonId].value = _value.toString().replace(cell, "($1) $2-$3");
            else {

                alert('Invalid data  entered in ' + fieldname + '. Please enter valid 10 digit ' + fieldname);
                //  document.forms[0].elements[oButtonId].value = '';
                document.forms[0].elements[oButtonId].focus();
            }
        }
        else {

        }



    }


}
function numberWithCommas(x) {
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}
function CheckBoxValidatorEvaluateIsValid(val) {
    var control = document.getElementById(val.controltovalidate);
    var mustBeChecked = Boolean(val.mustBeChecked);

    return control.checked == mustBeChecked;
}

function CheckBoxListValidatorEvaluateIsValid(val) {
    var control = document.getElementById(val.controltovalidate);
    var minimumNumberOfSelectedCheckBoxes = parseInt(val.minimumNumberOfSelectedCheckBoxes);

    var selectedItemCount = 0;
    var liIndex = 0;
    var currentListItem = document.getElementById(control.id + '_' + liIndex.toString());
    while (currentListItem != null) {
        if (currentListItem.checked) selectedItemCount++;
        liIndex++;
        currentListItem = document.getElementById(control.id + '_' + liIndex.toString());
    }

    return selectedItemCount >= minimumNumberOfSelectedCheckBoxes;
}

function IAMGridBeforeSortColumnHandler(gridHTMLId, columnHTMLId) {
    //LPD-88 Grid Sorting and Find Feature in Grids - Waiting frame is displayed for Dashboard and SearchResultsGrid only
    if (gridHTMLId.indexOf('Dashboard') > -1 || gridHTMLId.indexOf('searchResultsGrid') > -1)
        document.getElementById('WaitingFrame').style.display = "block";
    needToEvaluateChangedInPriorPostback = true;
     //Merge from 2.6.4 TFS-1770 Select All Functionality is not working when pagination exists.
    SetSelectallCheckBoxOnPagination();
    EvaluateChanges();
    window.onbeforeunload = "";
    //window.onbeforeunload = EvaluateChangesNoReturnValue;
    //alert('about to sort the grid');
}

function getElementsByClassName(cl) {
    var retnode = [];
    var myclass = new RegExp('\\b' + cl + '\\b');
    var elem = document.getElementsByTagName('*');
    for (var i = 0; i < elem.length; i++) {
        var classes = elem[i].className;
        if (myclass.test(classes)) retnode.push(elem[i]);
    }
    return retnode;
};

function assignInitialValuesForMonitorChanges() {

    for (var i = 0; i < monitorChangesIDs.length; i++) {

        var elem = document.getElementById(monitorChangesIDs[i]);
        if (elem) {
            if (elem.type == 'checkbox' || elem.type == 'radio') {
                monitorChangesValues[i] = elem.checked;
            }
            else {
                //alert(elem.value);
                monitorChangesValues[i] = elem.value;

            }



        }
    }

    ControlStyleOfTagControl();
    //alert('after assigning')

}


function TextkeyPress(e) {
    e = e || window.event;
    var unicode = e.charCode ? e.charCode : e.keyCode ? e.keyCode : 0;
    var btnEnterSearch = $get('emailControl_btnSearch');
    if (unicode == 13) {
        btnEnterSearch.click();
        return false;
        //hdnEnterValue.value = "true";
        //__doPostBack('', 'genericSearchForm1:btnSearch');
    }
    return true;
}

function isEmailAddress(EmailAddress) {
    var emailReg = '^[\\w-_\.+<]*[\\w-_\.]\@([\\w]+\\.)+[\\w]+[\\w>]$';
    var regex = new RegExp(emailReg);
    var check = regex.test(EmailAddress);
    if (check == true) {
        return true;
    }
    else {
        return false;
    }
}

//handling dynamic validation for hidden fields--on 31 aug, 2009

function DynamicValidationForHiddenFields() {
    try {
        var ValidatorIds = '';
        var hdnForLastInvalidatedIds = $get('hdnLastInvalidatedIds');
        if (hdnForLastInvalidatedIds) {
            if (hdnForLastInvalidatedIds.value) {
                // alert('previous hdnValue: '+hdnForLastInvalidatedIds.value);
                if (hdnForLastInvalidatedIds.value.length > 0) {
                    var ValidatorIdArray = hdnForLastInvalidatedIds.value.split(',');
                    for (var k = 0; k < ValidatorIdArray.length; k++) {
                        for (var j = 0; j < Page_Validators.length; j++) {
                            if (ValidatorIdArray[k] == Page_Validators[j].id) {
                                //alert('enabling '+ValidatorIdArray[k]);
                                ValidatorEnable(Page_Validators[j], true); //enable all the validators for required fields only before disabling them
                            }
                        }
                    }


                }
            }



            //alert("caught");
            var hdnVisibleObjectFields = document.getElementById('hdnVisibleObjectFieldIdsString');
            var hdnVisibleFields = document.getElementById('hdnVisibleFieldIdsString');

            if (hdnVisibleFields) {
                if (hdnVisibleFields.value.length > 0) {
                    //  alert("hdnvisiblefields ids: "+hdnVisibleFields.value);
                    var IdArray = (hdnVisibleFields.value).split('|'); //External1~681e35c6-ff86-4318-96e5-3d376589aa7f|External2~b971bfa4-884d-4fda-a879-e9f9cad36246|External3~85bc17d7-5370-48d5-8c43-910bffe8d698|Internal1~0c88c863-c27a-4fcf-97c6-2631ee61f888|
                    //alert(IdArray.length);
                    for (var i = 0; i < IdArray.length; i++)//For each trid
                    {
                        var VisibleFields = IdArray[i].split('~')[0]; //must have two parts e.g. External1~681e35c6-ff86-4318-96e5-3d376589aa7f
                        //alert(VisibleFields);
                        var fieldids = IdArray[i].split('~')[1]; // also treat more than two fields

                        if (fieldids)//if fields exist
                        {
                            var fieldIdArray = fieldids.split(',');
                            for (var l = 0; l < fieldIdArray.length; l++)//do it for all fields under in the tr
                            {
                                var fieldid = fieldIdArray[l]; //clientID

                                var fieldControl = $get(fieldid);
                                //alert('Fieldcontrol found: '+fieldControl);
                                //check if the field control is hidden
                                if (fieldControl) {
                                    //alert('visible field display style: '+fieldControl.style.display);
                                    if (fieldControl.style) {
                                        if (fieldControl.style.display) {
                                            if (fieldControl.style.display == 'none') {
                                                for (var j = 0; j < Page_Validators.length; j++)//iterate through all page validators and disable matching field validators
                                                {
                                                    try {
                                                        var Id = fieldid.substr(5); //extracting fieldid out of fieldGuid format
                                                        //alert(fieldid.substr(5));
                                                        if (Page_Validators[j].id.indexOf(Id) > -1)//if validator id contains fieldid
                                                        {
                                                            //alert('disabling validator for visible fields... '+Page_Validators[j].id);
                                                            ValidatorIds = ValidatorIds + Page_Validators[j].id + ',';
                                                            ValidatorIds = ValidatorIds + Page_Validators[j].id + ',';
                                                            ValidatorEnable(Page_Validators[j], false);
                                                        }
                                                    } catch (ex)
                                                                                { }

                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }


                }
            }

            if (hdnVisibleObjectFields) {
                if (hdnVisibleObjectFields.value.length > 0) {
                    // alert('Visible Objects: '+ hdnVisibleObjectFields.value);
                    var IdArray = (hdnVisibleObjectFields.value).split('|'); //External1~681e35c6-ff86-4318-96e5-3d376589aa7f|External2~b971bfa4-884d-4fda-a879-e9f9cad36246|External3~85bc17d7-5370-48d5-8c43-910bffe8d698|Internal1~0c88c863-c27a-4fcf-97c6-2631ee61f888|
                    //alert(IdArray.length);
                    for (var i = 0; i < IdArray.length; i++)//For each trid
                    {
                        var TrId = IdArray[i].split('~')[0]; //must have two parts e.g. External1~681e35c6-ff86-4318-96e5-3d376589aa7f
                        var fieldids = IdArray[i].split('~')[1]; // also treat more than two fields


                        if (TrId != null && TrId != '') {
                            var rowEle = $get(TrId);
                            if (rowEle) {
                                if (rowEle.style.display) {

                                    if (rowEle.style.display == "none")//if hidden, then get all fields inside this, and disable their validators
                                    {
                                        // alert(TrId);
                                        // alert('display: '+rowEle.style.display); 
                                        // alert(Page_Validators.length);

                                        if (fieldids)//if fields exist
                                        {

                                            var fieldIdArray = fieldids.split(',');
                                            for (var l = 0; l < fieldIdArray.length; l++)//do it for all fields under in the tr
                                            {
                                                var fieldid = fieldIdArray[l];
                                                // alert('field defined '+fieldid);
                                                for (var j = 0; j < Page_Validators.length; j++)//iterate through all page validators and disable matching field validators
                                                {
                                                    if (Page_Validators[j].id.indexOf(fieldid) > -1)//if validator id contains fieldid
                                                    {
                                                        //  alert('disabling validator... '+Page_Validators[j].id);
                                                        ValidatorIds = ValidatorIds + Page_Validators[j].id + ',';
                                                        ValidatorEnable(Page_Validators[j], false);
                                                    }

                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            //  alert('previous hdnValue: '+hdnForLastInvalidatedIds.value);

            if (ValidatorIds.length > 0)
                ValidatorIds = ValidatorIds.substr(0, ValidatorIds.length - 1);

            // alert('Id string: '+ValidatorIds);
            hdnForLastInvalidatedIds.value = ValidatorIds;
            // alert('Hdn value: '+ hdnForLastInvalidatedIds.value);


        }
        return true;
    } catch (exc) {
        //alert('error occurred');
    }

}



//Validate whether at least one record is selected in the dashboard grid before invoking ETWF call
//--on 11 aug, 2009
function ValidateForETWFCALL() {

    var goAhead = true;
    var goAheadForDashboard = false;
    //alert(document.form1.getElementsByTagName("DataForDashboard").length);
    if (document.form1.getElementsByTagName("DataForDashboard") != null) {
        var Dashboards = document.form1.getElementsByTagName("DataForDashboard");
        //alert('Dashboards.length: '+Dashboards.length);     
        //alert(Dashboards.item(0).getAttribute("DashboardId"));
        //alert(Dashboards.item(1).getAttribute("DashboardId"));

        for (var ii = 0; ii < Dashboards.length; ii++) {

            var Dashboard = Dashboards.item(ii);
            var DashboardId = Dashboard.getAttribute("DashboardId");
            //alert(DashboardId);
            //create id for the grid
            var gridID;
            var grid;
            /*Condition for Old Grid Control and New Grid Control*/
            var enabledNewGrid = enabledNewGridControl; // Tfs Bug - 751: Patent -> Awards -> The records were not getting saved in an Old grid view - Ishita
            if (enabledNewGrid == "False") {
                gridID = 'Dashboard' + DashboardId + 'xsearchResultsGridxobjectsGridxinnerGrid';
                //alert(gridID);
                grid = igtbl_getGridById(gridID);
            }
            else {
                gridID = 'Dashboard' + DashboardId + '_searchResultsWebDataGrid_objectsGrid_innerGrid';
                grid = $find(gridID);
            }

            // alert('grid' +grid);
            if (grid == null)//check whether the dashboard is inside a IAMPanel
            {
                var inputCtrls = Dashboard.getElementsByTagName('input').length;
                //alert(inputCtrls);
                if (inputCtrls > 0) {
                    for (var k = 0; k < inputCtrls; k++) {
                        var ucName = Dashboard.getElementsByTagName('input')[0].id;
                        if (ucName.indexOf('RadPanelBar') > -1 && ucName.indexOf('_chkSelectAll') > -1)//if selectAll checkbox,
                        {
                            /*Condition for Old Grid Control and New Grid Control*/
                            if (enabledNewGrid == "False") {
                                ucName = ucName.replace('_i0_i0_', 'xi0xi0x');
                                gridID = ucName.replace('_chkSelectAll', 'xsearchResultsGridxobjectsGridxinnerGrid');
                                grid = igtbl_getGridById(gridID);
                            }
                            else {
                                ucName = ucName;
                                gridID = ucName.replace('_chkSelectAll', '_searchResultsWebDataGrid_objectsGrid_innerGrid');
                                grid = $find(gridID);
                            }
                            // alert(grid);
                            break;
                        }
                    }
                }
            }
            /* Else condition is not required
            else {
            alert('grid!=null');
            }
            */

            if (grid != null)// grid found on the Page...
            {
                /*Condition for Old Grid Control and New Grid Control*/
                if (enabledNewGrid == "False") {

                    // alert('Totals bands: '+grid.Bands.length);
                    // alert('View Type: '+grid.ViewType);
                    if (grid.Bands.length > 2)//when grouped by, then there is at least three bands
                    {
                        for (var rowIndex = 0; rowIndex < grid.Rows.length; rowIndex++) {
                            var children = grid.Rows.getRow(rowIndex).getChildRows();
                            //alert(children.length);
                            for (i = 0; i < children.length; i++) {
                                var childRow = igtbl_getRowById(children[i].id);
                                //  alert( childRow.getCellFromKey('Delete').getValue());
                                //alert(grid.Rows.getRow(rowIndex).getRow(0).getCellFromKey("Delete").getValue());
                                if (childRow != null) {
                                    //alert(childRow.getCellFromKey("Delete").getValue());
                                    if (childRow.getCellFromKey("Delete").getValue().toLowerCase() == "true") {
                                        goAheadForDashboard = true;
                                        if (goAheadForDashboard) {
                                            //alert('break now');
                                            break;
                                        }

                                    }
                                }
                            }
                        }

                    }
                    else//non-grouped View 
                    {
                        for (var rowIndex = 0; rowIndex < grid.Rows.length; rowIndex++) {
                            //  alert(grid.Rows.getRow(rowIndex).getCellFromKey("Delete").getValue().toLowerCase());
                            // alert(grid.Rows.getRow(rowIndex).getCellFromKey("Delete").getValue().toLowerCase() == "true");
                            if (grid.Rows.getRow(rowIndex).getCellFromKey("Delete") != null) {
                                if (grid.Rows.getRow(rowIndex).getCellFromKey("Delete").getValue().toLowerCase() == "true") {
                                    //alert('goAheadForDashboard '+goAheadForDashboard);
                                    goAheadForDashboard = true;
                                    //alert('goAheadForDashboard '+goAheadForDashboard);
                                    if (goAheadForDashboard) {
                                        //alert('break now');
                                        break;
                                    }

                                }
                            }
                        }
                    }
                } /*Old Grid Condition End here...*/
                else { /*New Grid condition start here...*/
                    var colIndex = grid.get_gridView().get_columns().get_columnFromKey('Delete')._visibleIndex;
                    for (i = 0; i < grid.get_gridView().get_rows().get_length(); i++) {
                        //goAheadForDashboard = (grid.get_gridView().get_rows().get_row(i).get_cell(colIndex)._column._isCheck);
                        goAheadForDashboard = (grid.get_gridView().get_rows().get_row(i).get_cell(colIndex).get_value() == true);
                        if (goAheadForDashboard)
                            break;
                    }
                }
            }
            else//else this is datalist view
            {
                //alert(DashboardId);
                var datalistDiv = document.getElementById('Dashboard' + DashboardId + '_divForDatalist');
                if (datalistDiv != null) {
                    var checkboxColl = datalistDiv.getElementsByTagName('input');
                    //   var theForm = document.forms['form1'];
                    //                    if (!theForm)
                    //                     {
                    //                        theForm = document.form1;
                    //                     }
                    //	               var frm = theForm;
                    // for(i = 0; i < frm.length; i++)
                    for (i = 0; i < checkboxColl.length; i++) {
                        // e = frm.elements[i];
                        var e = checkboxColl.item(i);
                        if (e.type == 'checkbox' && e.name.indexOf('chkItemBox') != -1) {
                            // alert(' DATALIST CHECKBOX ' + e.checked);
                            if (e.checked) {
                                goAheadForDashboard = true;
                                if (goAheadForDashboard) {
                                    //alert('break now 1');
                                    break;
                                }

                            }
                        }

                    }
                }

            }

            // alert('all dashboard status '+goAheadForDashboard);       
            if (goAheadForDashboard) {
                //alert('break now 2');
                break;
            }

            //alert('loop ends here');
        } //main loop ends here




    }
    //        alert('all dashboard status ' + goAheadForDashboard);   
    //        alert('GoAhead: ' + goAhead);
    goAhead = goAhead && goAheadForDashboard;

    if (goAhead) {
        return true;
    }
    else {

        if (grid != null)
            alert('At least one record must be selected to process desired action!'); // before invoking workflow at Dashboard level
        else
            alert('At least one record must be selected to process desired action!');

        return false;
    }

}

function CheckAll(checkAllBox, fieldName) {
    //alert('entered!');
    var theForm = document.forms['form1'];
    if (!theForm) {
        theForm = document.form1;
    }
    var frm = theForm;
    var actVar = checkAllBox.checked;
    //alert(actVar);
    //alert(frm);
    for (i = 0; i < frm.length; i++) {
        e = frm.elements[i];

        if (e.type == 'checkbox' && e.name.indexOf(fieldName) != -1) {
            //alert(fieldName);
            //alert(e.name);
            e.checked = actVar;
        }

    }
}


//added for monitoring purposes of itemslist in the autofilter control  -- on 21 Jan
function ReturnItemListOfAutofiltercontrol(obj) {

    //var obj=$get(); //'StructureRelationshipGrid194c8bd1Zcc44Z4a32Z83b0Z1f684ac08720_ddlAutoComplete'
    var ItemText = '';
    try {
        if (obj != null) {

            if ((navigator.userAgent.match(/Firefox/i) != null)) {
                for (var cnt = 0; cnt < obj.childNodes.length; cnt++) {
                    if (obj.childNodes[cnt].textContent != null && obj.childNodes[cnt].className != 'VirtualCursor') {
                        if (obj.childNodes[cnt].textContent.length > 0) {
                            // alert(obj.childNodes[cnt].className);

                            //if(cnt!=obj.childNodes.length-1)
                            // {
                            ItemText += obj.childNodes[cnt].textContent.trim() + ';.;';
                            //  }
                            // else 
                            //  {
                            //if(obj.childNodes[cnt].className!='VirtualCursor')
                            //  ItemText+=obj.childNodes[cnt].textContent.trim();
                            //   }

                        }
                    }
                }
            }
            else {
                for (var cnt = 0; cnt < obj.childNodes.length; cnt++) {
                    if (obj.childNodes[cnt].innerText != null && obj.childNodes[cnt].className != 'VirtualCursor') {
                        if (obj.childNodes[cnt].innerText.length > 0) {
                            //   if(cnt!=obj.childNodes.length-1)//non-last elements     
                            ItemText += obj.childNodes[cnt].innerText.trim() + ';.;';
                            //   else
                            //  ItemText+=obj.childNodes[cnt].innerText.trim();

                        }
                    }
                }
            }

            if (ItemText.length > 2 && ItemText.trim().lastIndexOf(';.;') == ItemText.length - 3)//ensure there is the delimiter in the end
                ItemText = ItemText.substring(0, ItemText.length - 3); //remove delimiter

        }
    } catch (ex) {

    }
    return ItemText;
}




function ControlStyleOfTagControl() {
    try {

        //not sure, how many autofilter controls can be placed on the page, hence iterate all through
        var divArray = document.getElementsByTagName('div'); //.getElementsByName('idbuttongroup');//getElementsByClassName('TableHeaderForRelatedObjectDropdown');
        //alert(divArray.length);
        for (var cnt1 = 0; cnt1 < divArray.length; cnt1++) {
            if (divArray[cnt1].className == 'TableHeaderForRelatedObjectDropdown') {
                var tdArray = divArray[cnt1].getElementsByTagName('td');
                for (var cnt = 0; cnt < tdArray.length; cnt++) {
                    if (tdArray[cnt].id == 'mainTD') {
                        // alert(navigator.userAgent.match(/MSIE/i)!=null);
                        if (navigator.userAgent.match(/MSIE/i) != null) {
                            //  alert('setSTYLE IN IE');
                            tdArray[cnt].align = 'right';
                            tdArray[cnt].width = '200px';
                        } else {
                            // alert('setSTYLE IN NON-IE');
                            tdArray[cnt].style.setProperty("text-align", "right", "important");
                            tdArray[cnt].style.setProperty("width", "200px", "important");
                        }
                    } else {
                        // alert('td not found');
                    }

                }
            }

        }
    }
    catch (ex) {

    }

}


function PersistingViewStateForSafari() {

    //alert('on load');
    var divArray = document.getElementsByTagName('div'); //.getElementsByName('idbuttongroup');//getElementsByClassName('TableHeaderForRelatedObjectDropdown');
    //alert(divArray.length);
    for (var cnt1 = 0; cnt1 < divArray.length; cnt1++) {
        if (divArray[cnt1].className == 'TableHeader')//identifies for structureRelatioships and typeHierarachys
        {
            //alert('calling: '+divArray[cnt1].id);
            ReloadRelationshipGrids(divArray[cnt1].id);

        }
    }

}






function ReloadRelationshipGrids(strBookHashURL) {
    // TestAlert("ReloadRelationshipGrids");


    var gridID = strBookHashURL.substr(0, strBookHashURL.indexOf('_'));
    gridID = gridID + 'xiamGrid1xinnerGrid';
    //alert(gridID);
    var gridControl = igtbl_getGridById(gridID);
    // alert(gridControl);
    // alert(typeof(gridControl));
    if (typeof (gridControl) == 'undefined')
        return false;


    var iLenRow = gridControl.Rows.length;
    if (iLenRow > 0) {
        var iLenColumn = gridControl.Bands[0].Columns.length;
        var gridRowRecords = new Array();
        for (var iRows = 0; iRows < iLenRow; iRows++) {
            var columnRecord = '';
            for (var iColumn = 0; iColumn < iLenColumn; iColumn++) {
                if (iColumn == 0) {
                    if (gridControl.Rows.getRow(iRows).getCell(iColumn).getValue() != null) {
                        columnRecord = gridControl.Rows.getRow(iRows).getCell(iColumn).getValue();
                    }
                    else {
                        columnRecord = '';
                    }
                }
                else {
                    if (gridControl.Rows.getRow(iRows).getCell(iColumn).getValue() != null) {
                        columnRecord = columnRecord + '%%%%%%' + gridControl.Rows.getRow(iRows).getCell(iColumn).getValue();
                    }
                    else {
                        columnRecord = columnRecord + '%%%%%%' + '';
                    }
                }
            }
            gridRowRecords[iRows] = columnRecord;
        }


        gridControl.AllowDelete = 1;
        gridControl.AllowUpdate = 1;
        gridControl.AllowAddNew = 1;


        var iRowDelete;
        //alert(gridControl.style.display);


        // alert(iLenRow);    
        // alert('grid Loaded: '+gridControl.GridIsLoaded);

        //alert('fix works for deleting all rows: '+iLenRow+'  For:'+strBookHashURL);
        for (iRowDelete = 0; iRowDelete < iLenRow; iRowDelete++) {
            igtbl_deleteRow(gridID, gridID + '_r_' + iRowDelete);
        }

        var gridRow = null;
        //alert('fix works for adding with rows: '+iLenRow);
        for (var iRowAdded = 0; iRowAdded < iLenRow; iRowAdded++) {
            gridRow = igtbl_addNew(gridID, 0);
            var dataRow = gridRowRecords[iRowAdded];
            var columnRow = dataRow.split('%%%%%%');

            for (var iColumnAdded = 0; iColumnAdded < iLenColumn; iColumnAdded++) {
                //alert(columnRow[iColumnAdded]);
                var iStart = columnRow[iColumnAdded].toLowerCase().indexOf("<a");
                var iEnd = columnRow[iColumnAdded].toLowerCase().indexOf("</a>");
                var iLength = columnRow[iColumnAdded].length;
                if (iStart == 0 && (iEnd == (iLength - 4))) {
                    gridRow.getCell(iColumnAdded).getElement().innerHTML = columnRow[iColumnAdded];
                }
                else {
                    gridRow.getCell(iColumnAdded).setValue(columnRow[iColumnAdded]);
                }
            }
        }
        //  gridControl.endEdit();
        //  alert('fix works for adding with rows: '+gridControl.Rows.length);
    } else {
        gridControl.MainGrid.style.display = 'none';
        // alert('hide the empty grid');
    }

}



function ReadOnly(e) {
    // alert('hey');
    var target = e.target ? e.target : e.srcElement;
    //alert(target.href);
    target.className = "";
    target.href = "";
    //alert(target.href);
    return false;


}

function ByPassValidationOnly() {

    needToConfirm = false;
    try {

        for (var j = 0; j < Page_Validators.length; j++) {
            ValidatorEnable(Page_Validators[j], false); //enable all the validators for required fields only before disabling them
        }
    }
    catch (e) {
    }


    document.form1.txtSubmitForm.value = "ByPassValidationOnly";

    return true;



}


/*** borrowed from myresearch.js starts here****/

function IsSafari() { return (navigator.userAgent.match(/safari/i) != null) };
function IsIE() { return (navigator.userAgent.match(/MSIE/i) != null) };
function IsFireFox() { return (navigator.userAgent.match(/Firefox/i) != null) };

function SettoCenter(IdOfDiv) {

    var myWidth = 0, myHeight = 0, myScrolTop = 0;

    if (typeof (window.innerWidth) == 'number') {
        //Non-IE
        myWidth = window.innerWidth;
        myHeight = window.innerHeight;
        myScrolTop = window.scrollTop;

    } else if (document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)) {
        //IE 6+ in 'standards compliant mode'
        myWidth = window.screen.availWidth;
        myHeight = document.documentElement.clientHeight;
        myScrolTop = document.documentElement.scrollTop;

    } else if (document.body && (document.body.clientWidth || document.body.clientHeight)) {
        //IE 4 compatible
        myWidth = document.body.clientWidth;
        myHeight = document.body.clientHeight;
        myScrolTop = document.body.scrollTop;

    }


    if (IsSafari()) {
        myScrolTop = document.body.scrollTop;
    }
    else {
        myScrolTop = document.documentElement.scrollTop;
    }

    var myScrollLeft = document.documentElement.scrollLeft + document.body.scrollLeft;
    myScrolTop = document.documentElement.scrollTop + document.body.scrollTop;
    var DivId = document.getElementById(IdOfDiv);

    DivId.style.display = "block";

    var leftofDiv = (myWidth / 2) - (DivId.offsetWidth / 2) + myScrollLeft;
    var topofDiv = (myHeight / 2) - (DivId.offsetHeight / 2) + myScrolTop;

    if ((IsFireFox()) || (IsSafari())) {
        DivId.style.setProperty("position", "absolute", "important");
        DivId.style.setProperty("left", leftofDiv + "px", "important");
        DivId.style.setProperty("top", topofDiv + "px", "important");
    }
    else {
        DivId.style.position = "absolute";
        DivId.style.left = leftofDiv;
        DivId.style.top = topofDiv;
    }


    return false;
}

/*** borrowed from myresearch.js ends here****/

function TestAlert(MSG) {
    //alert(MSG);
}


function OnCallComplete(result, userContext, methodName) {
    // TestAlert('Callback succeeded for PageMethod ');
    // TestAlert('Skipped Or Not: '+result);
    if (result > 0)//apply logic of automatic session end
    {

        if (result == 1) {
            // TestAlert('Apply Timer logic');
            if (SessionAlertTimeout > 1) {
                radconfirm("Your Session is about to Expire in " + SessionAlertTimeout + " minutes. Click OK to continue or Click Cancel to logout.", confirmCallBackFn, 350, 150, null, "Session Logout");
            }
            else if (SessionAlertTimeout == 1) {
                radconfirm("Your Session is about to Expire in " + SessionAlertTimeout + " minute. Click OK to continue or Click Cancel to logout.", confirmCallBackFn, 350, 150, null, "Session Logout");
            }

            DisableFrameTop();
            timeChangeTitle = setTimeout('ChangeTitle()', (10000));
            timeForceSessionOut = setTimeout('ForceSessionOut()', (parseInt(parseInt(parseInt(SessionAlertTimeout) * 1000 * 60) - 10000)));
        }
        else if (result == 2) {
            LogOutSession();
        }

    } else //reset the timer
    {
        //TestAlert('Resetting Timer');
        //clearTimeout(timeChangeTitle);
        //clearTimeout(timeForceSessionOut);
        //TestAlert(timeSessionOut);
        methodCalledAtLoad = null;
        SessionMessage(timeSessionOut);
    }
}

function OnCallError(error, userContext, methodName) {
    if (error !== null) {
        // alert(error.get_message());            
    }
}

function EvaluateExportToExcel(totalCount, RecordsLimit, hiddentxtNoOfRecords) {
    // Bug # 599 : After filtering record export was not working - Kalpesh Rathod
    var blnExportOk = true;
    var txtNoOfRecords = document.getElementById(hiddentxtNoOfRecords);
    var totalCount = txtNoOfRecords.value;
    if (totalCount > RecordsLimit) {
        blnExportOk = false;
        alert('Records more than ' + RecordsLimit + ' cannot be exported to excel in one go!');
    }

    return blnExportOk;

}

function EvaluateExportToPdf(totalCount, RecordsLimit, hiddentxtNoOfRecords) {
    // Bug # 599 : After filtering record export was not working - Kalpesh Rathod
    var blnExportOk = true;
    var txtNoOfRecords = document.getElementById(hiddentxtNoOfRecords);
    var totalCount = txtNoOfRecords.value;
    if (totalCount > RecordsLimit) {
        blnExportOk = false;
        alert('Records more than ' + RecordsLimit + ' cannot be exported to pdf in one go!');
    }

    return blnExportOk;

}

function EvaluateDownloadAttachments(totalCount, RecordsLimit, gridId) {
    // Bug # 599 : After filtering record export was not working - Kalpesh Rathod
    var blnExportOk = true;
    var txtNoOfRecords = document.getElementById(hiddentxtNoOfRecords);
    var totalCount = txtNoOfRecords.value;
    if (totalCount > RecordsLimit) {
        blnExportOk = false;
        alert('Records more than ' + RecordsLimit + '. Cannot download attachments in one go!');
    }

    return blnExportOk;

}
function checkfileexist(fileexists) {
    alert(fileexists + ' file not found at location specified in merge PDF field');
}
/// <summary>
/// Requirement:969 - Double Prompt Version 2.7
/// Implemented By: Bijal Vakharia on 27-Nov-2013
/// Integrated in Version: 2.7
/// Requested By  Client: Google
/// Impacted Function : CreateFieldInfo(IDataReader dr)
/// Impacted Files :
/// IAM\Admin\ETTF\Field.aspx
/// IAM\Admin\ETTF\Field.aspx.cs
/// IAM\Runtime\EntityObject.aspx
/// IAM\Runtime\EntityObject.js
/// IAM\WebComponents\JavascriptUtils.cs
/// IAM\WebComponents\DynamicControlUtils.cs
/// BLL\ETTF\Runtime\CachedStructure\Field.cs
/// DAL\ETTF\Structure\Field.cs
/// Model\ETTF\Structure\FieldInfo.cs
/// </summary>
function EvaluateDoublePrompt(curCtl) {
    var ctl = $("#" + curCtl);
    //Logic for ReplaceDoubleQuotes function
    var singleQuote = "'";
    ctl.val(ctl.val().replace(/"/g, singleQuote));

    var doublepromptVal = $("#" + curCtl).attr('prevVal');
    var doublepromptValCount = $("#" + curCtl).attr('prevValCnt');
    var validValue = $("#" + curCtl).attr('validVal');
    if (doublepromptVal == undefined) doublepromptVal = '';
    if (doublepromptValCount == undefined) doublepromptValCount = 0;
    if (validValue == undefined) validValue = '';
    if (parseInt(doublepromptValCount) >= 3) {
        doublepromptVal = '';
    }
    if ((ctl.val() != '' && doublepromptVal == '') || (validValue != '' && validValue != ctl.val())) {
        alert('Please enter data again for verification');
        ctl.attr('prevVal', ctl.val());
        ctl.attr('prevValCnt', 0);
        ctl.attr('validVal', '');
        ctl.val('')
        ctl.focus();
    }
    else if (doublepromptVal != '' && ctl.val() == doublepromptVal) {
        doublepromptVal = '';
        ctl.attr('validVal', ctl.val());
        ctl.attr('prevValCnt', 0);
    }
    else if (ctl.val() != '') {
        alert('You have entered wrong value, it is not matched with previous entry.');
        ctl.attr('prevValCnt', parseInt(doublepromptValCount) + 1);
        ctl.val('')
        ctl.focus();
    }
}
/// <summary>
/// Requirement:968 - Data Validation Version 2.7
/// Implemented By: Bijal Vakharia on 27-Nov-2013
/// Integrated in Version: 2.7
/// Requested By  Client: Google
/// </summary>
function getFieldID(ctl) {
    ctl=ctl.toString().replace(/-/g, 'Z')
    if ($("#" + ctl).length > 0) {        
            return $("#" + ctl);        
    }
    else if ($("input[id*='" + ctl + "']").length > 0) {
        return $("input[id*='" + ctl + "']");
    }    
    else if ($("select[id*='" + ctl + "']").length > 0) {
        return $("select[id*='" + ctl + "']");
    }
    return null;
}

function getFieldValue(ctl) {
    ctl = ctl.toString().replace(/-/g, 'Z')
    if ($("#" + ctl).length > 0) {
        if ($("#" + ctl).is("select")) {
            return $("#" + ctl + " option:selected").text();
        }
        else {
            return $("#" + ctl).val();
        }
    }
    else if ($("input[id*='" + ctl + "']").length > 0) {
        return $("input[id*='" + ctl + "']").val();
    }
    //Requirement:968 - Data Validation Version 2.7 When radpanel exists
    else if ($("select[id*='" + ctl + "']").length > 0) {
        return $("select[id*='" + ctl + "'] option:selected").text();
    }

}
//Resolved Bug 1278 data validation overrights the validation of a field.
function validateDependentFieldIsBlank(dFields) {
    var retVal = true;
    $(dFields).each(function (index) {
        if (eval(dFields[index]) == '') retVal = false;
    });
    return retVal;
}
//Resolved Bug 1278 data validation overrights the validation of a field.
function evaluateExpressionfunction(event) {
    for (var i = 0; i < event.data.length; i++) {
        if (validateDependentFieldIsBlank(event.data[i].d)) {
            eval(event.data[i].e);
        }
    }
}
//Resolved Bug 1599: 2.7: Oracle : Masking is not working in Oracle for PCT/Utility case typa and application number .Masking is not working for the controls which are placed in RadPanel
function evaluateMaskingfunction(mk) {        
            eval(mk);        
}
function removeMessage(nm) {
    $("#expressionSummary ul li[nm='" + nm + "']").remove();
}
function showAlterMessage(msg, nm) {
    removeMessage(nm);
    $("#expressionSummary ul").append("<li nm='" + nm + "'>" + msg + "</li>");
}

/// <summary>
/// Requirement:967/Task:1237 - WorkFlowCascading  Version 2.7
/// Implemented By: Kalpesh Rathod on 2-Feb-2014
/// Integrated in Version: 2.7
/// Requested By  Client: 
/// Calling Function : LoadOperationButtons(Guid fieldId, string possibleValues, bool bIsPreviewPage, string tooltip)
/// Impacted Files :
/// IAM\Controls\OperationButtonsStrip.ascx.cs
/// </summary>
function PromptForWorkFlowRedoConfirmation(typeId, currentObjectId) {


    var url = "AuditData.aspx?RedoWorkFlow=true&TypeSequence=" + typeId + "&CurrentObjectId=" + currentObjectId;
    win.setUrl(url);
    win.PopupWindow_showPopupWorkerForModelPopUp(300, 150, "window_FielterValueLookup");
    userResponse = false;
    
    return userResponse;

}

//TFS: 1302-JAWS : Auto Tabing functionality in Working Area Frame
function Focus() {
    //TFS-1314: JAWS:checkboxes on column (Grid ) are not readable.Not able to select checkboxes in the grid through tab. Start.
    var chkBox = $('img[src^="../ig_res/Default/images/ig_checkbox"]');
    chkBox.attr('tabindex', '0');
    for (iCounter = 0; iCounter < chkBox.length; iCounter++) {
        if (chkBox != undefined && chkBox.length > 0) {
            chkBox.eq(iCounter).keydown(function (e) {
                if (e.which == 32 && e.keyCode == 32) {
                    var chkstate = this.attributes.chkstate.value;

                    if (chkstate == '0') {
                        this.attributes.chkstate.value = '1';
                        this.attributes.src.value = '../ig_res/Default/images/ig_checkbox_on.gif';
                        this.attributes.alt.value = 'checked';
                        this.attributes.title.value = 'checked';

                    }
                    if (chkstate == '1') {
                        this.attributes.chkstate.value = '0';
                        this.attributes.src.value = '../ig_res/Default/images/ig_checkbox_off.gif';
                        this.attributes.alt.value = 'Unchecked';
                        this.attributes.title.value = 'Unchecked';
                    }
                }
            });
        }
    }

    //JAWS:checkboxes on column (Grid ) are not readable.Not able to select checkboxes in the grid through tab.End
    AppendVolumIconInTableHeader(); //Jaws: Navigation from one section to the other in the Home page. Task # 1392 - Hridya
    var twice = 0;
    var incnt = 0;
    var frame = "all";
    var refreshId = setInterval(function () {
        switch (frame) {
            case (frame = "all"):
                {
                    var cntli = $("#typeDisplayContextPanel ul.sectionOptions li a.hyperlink ").length; //Jaws: Navigation from one section to the Other. Task # 1392 
                    $("#typeDisplayContextPanel ul.sectionOptions li a.hyperlink  :eq(" + incnt + ")").focus();

                    incnt = incnt + 1;
                    if (cntli <= (incnt)) {
                        sw = "master";
                        incnt = 0;
                        clearInterval(refreshId);
                    }
                    break;
                }

        }
    }, 2000);


    // TFS:1303 -JAWS Stop and Resume functionality
    $(document).keydown(function (e) {

        if (e.ctrlKey && incnt > 0) {
            twice = twice + 1;
            clearInterval(refreshId);
        }


        if (e.which == 82 && e.shiftKey) {

            if (incnt > 0 && twice != 0) {

                refreshId = setInterval(function () {
                    twice = 0;
                    var cntlii = $("#typeDisplayContextPanel ul.sectionOptions li a.hyperlink").length; //Jaws: Navigation from one section to the Other. Task # 1392 
                    $("#typeDisplayContextPanel ul.sectionOptions li a.hyperlink :eq(" + (incnt) + ")").focus();

                    incnt = incnt + 1;

                    if (cntlii <= (incnt)) {

                        incnt = 0;

                        clearInterval(refreshId);

                    }

                }, 2000);
            }

        }


    })

}


/// <summary>
/// Requirement:968 - Data Validation Version 2.7
/// Implemented By: Bijal Vakharia on 27-Nov-2013
/// Integrated in Version: 2.7
/// Requested By  Client: Google
/// </summary>
$(document).ready(function () {

    /* Jaws This method is used to assigned current selected tab in title */
    var typeDisplayContextLink = $('a[class="rtsLink rtsSelected"]');
    var titleObject = $('a[id^="editLink"][title^="Type dipslay context link, It has following links"]');
    if (titleObject != undefined && titleObject.length > 0) {
        var currentlySelectedTab = typeDisplayContextLink[0].textContent;
        //alert(currentlySelectedTab);
        title = (titleObject.attr('title').replace('~***~', currentlySelectedTab));
        //alert(title);
        $('a[id^="editLink"][title^="Type dipslay context link, It has following links"]').attr('title', title);
    }

    /* Jaws This method is used to assigned current selected tab in title */


    if (typeof (expressionEvalution) != "undefined") {
        $(expressionEvalution).each(function () {
            $(this.f).each(function () {
                var ef = this.ef;
                var ev = this.ev;
                for (i = 0; i < ef.length; i++) {
                    if (ef[i] == "saveButton" || ef[i] == "resetButton" || ef[i] == "pnlDelete" || ef[i] == "pnlBack" || ef[i] == "pnlAudit" || ef[i] == "pnlClone" || ef[i] == "addNewSiblingButton" || ef[i] == "addNewButton" || ef[i] == "callEtwfButton") {
                        ef[i] = 'objectButtonsStrip0_' + ef[i];
                    }
                    if (ef[i].indexOf(":") > -1) {
                        var pre = ef[i].split(':')[0];
                        var val = ef[i].split(':')[1];
                        var cid = $("input[id*='" + pre + "'][value='" + val + "']");
                        if (cid.length > 0)
                            ef[i] = cid.attr('id');
                    }
                    var ctl = $("#" + ef[i]);
                    if (ctl.length == 0) {
                        ctl = $("select[id*='" + ef[i] + "']");
                    }
                    if (ctl.length > 0) {
                        if (ctl.is("input[type='text']")) {                           
                            ctl.blur(ev, function (event) {
                                evaluateExpressionfunction(event);
                            });
                        }
                        else if (ctl.is("input[type='submit']")) {
                            ctl.click(ev, function (event) {
                                evaluateExpressionfunction(event);
                            });
                        }
                        else if (ctl.is("select")) {
                            ctl.change(ev, function (event) {
                                evaluateExpressionfunction(event);
                            });
                        }
                        //Resolved Bug 1599: 2.7: Oracle : Masking is not working in Oracle for PCT/Utility case typa and application number .Masking is not working for the controls which are placed in RadPanel
                        $(this.ev).each(function (i) {
                            if(this.m !=null && this.m!="")
                                evaluateMaskingfunction(this.m);
                           
                        });
                    }
                }
            });
        });
    }    
});
/*
Summary: New Grid Cell Value Changed events, Specially developed for CheckBox Change Event...
Develope By: Yogesh Shah
*/
function cellValueChanged(sender, eventArgs) {
    //alert(sender);
    var grid = $find(sender._id);
    var enabled = false;
    //alert(grid.get_rows().get_length());
    //alert(grid.get_gridView().get_rows().get_length());
    //Not include get_gridView() method as we are getting the child table only...
    for (i = 0; i < grid.get_rows().get_length(); i++) {
        if (grid.get_rows().get_row(i).get_cellByColumnKey("Delete").get_value()) {
            enabled = true;
            break;
        }
    }
    var deletebuttonName = sender._id.toString();
    //alert(deletebuttonName);
    deletebuttonName = deletebuttonName.substring(0, deletebuttonName.indexOf("_iamWebDataGrid1_innerGrid_ctl00"));
    deletebuttonName = deletebuttonName + '_btnDelete';
    //alert(deletebuttonName);
    //alert(enabled);
    //alert($(deletebuttonName));
    if ($(deletebuttonName) != null) {
        if (enabled) {
            var attr = $('#' + deletebuttonName).attr("disabled");
            if (typeof attr !== 'undefined' && attr !== false)
                $('#' + deletebuttonName).removeAttr('disabled');
        }
        else {
            $('#' + deletebuttonName).attr('disabled', true);
        }
    }
    //alert('Completed');
}

/*
Summary: New Grid Cell Entered Edit Mode events, Specially developed for Set the value of CheckBox...
Develope By: Yogesh Shah
*/
function enteredEditMode(sender, eventArgs) {
    //alert(sender);
    var rowid = eventArgs._cell._row._index;
    var grid = $find(sender._id);
    var checked = false;
    //alert(sender._id);
    if (grid != undefined && grid != null) {
        checked = grid.get_rows().get_row(rowid).get_cellByColumnKey("Delete").get_value();
        if (checked == false) {
            grid.get_rows().get_row(rowid).get_cellByColumnKey("Delete").set_value('true');
        }
    }
}

/*
function exitedEditMode(sender, eventArgs) {
var grid = $find(sender._id);
var editBehavior = grid.get_behaviors().get_editingCore();
editBehavior.commit();
alert('Completed');
var cell = eventArgs.getCell();
var val = cell.get_text();
cell.set_text(val);
}
*/
function fnSendPatentEmailsFolder(pnlSendPatentEmails, txtSendPtntEmailsTo) {
    var pnl = document.getElementById(pnlSendPatentEmails);

    var txtClear = document.getElementById(txtSendPtntEmailsTo);
    txtClear.value = '';
    if (pnl.style.display == 'block') {
        pnl.style.display = 'none';

        return false;
    }
    else {
        pnl.style.display = 'block';
        $('textarea[id="txtSendPtntEmailsTo"]').focus(); //TFS 1635-JAWS: Focus is not moving inside the popup on email link click .
        return SettoCenter(pnlSendPatentEmails);
    }
}

function fnSendPatentEmailsOk(txtSendPtntEmailsTo, pnlSendPatentEmails) {
    var EmailAddress = $get(txtSendPtntEmailsTo).value;
    var strEmail = EmailAddress.replace(/\s/g, '');
    strEmail = strEmail.replace(/,/g, ';');
    strEmail = strEmail.split(';');
    var flag = false;

    for (var iStr = 0; iStr < strEmail.length; iStr++) {
        if (isEmailAddress(strEmail[iStr]) == false) {
            flag = true; break;
        }
    }
    if (flag == true) {
        alert('Error in Email address.');
        return false;
    }
    else {
        document.getElementById(pnlSendPatentEmails).style.display = 'none';
    }
}

function fnsendPtntEmailsCancel(pnlSendPatentEmails) {
    document.getElementById(pnlSendPatentEmails).style.display = 'none';
    return false;
}

function fnEmailOK(txtSendPtntEmailsTo, emailControl_txtSearch, emailControl_lblErrorMessage, emailControl_testFrame, emailControl_txtToEmail, dvEmail, emailControlxdgEmailxinnerGrid) {
    var ToEmail = document.getElementById(txtSendPtntEmailsTo);
    var txtSearch = document.getElementById(emailControl_txtSearch);
    txtSearch.value = '';
    document.getElementById(emailControl_lblErrorMessage).style.display = 'none';
    document.getElementById(emailControl_testFrame).style.display = 'none';
    var EmailAddress = document.getElementById(emailControl_txtToEmail).value;
    var strEmail = EmailAddress.replace(/\s/g, ''); strEmail = strEmail.replace(/,/g, ';');
    strEmail = strEmail.split(';'); var flag = false;
    for (var iStr = 0; iStr < strEmail.length; iStr++) {
        if (isEmailAddress(strEmail[iStr]) == false) {
            flag = true; break;
        }
    }
    if (flag == true) {
        alert('Error in Email address.');
    }
    else {
        if (ToEmail.value == '') {
            ToEmail.value = EmailAddress;
        } else {
            ToEmail.value = ToEmail.value + ';' + EmailAddress;
        }
        txtSearch.value = '';
        document.getElementById(dvEmail).style.display = 'none';
        var gridName = emailControlxdgEmailxinnerGrid;
        var gridControl = igtbl_getGridById(gridName);
        var iLen = gridControl.Rows.length;
        for (var i = gridControl.Rows.length - 1; i > -1; i--) {
            gridControl.Rows.remove(i);
        }
    }
    return false;
}
//Dipika Arora :- Task 1615 : Summary Callout Version 2.7
//Function added to show the callout
function ShowCallOut(calloutId, triggerSelector) {    
    if ($.bt == undefined) {
        $.noConflict(true);
        jQuery.noConflict(true);
    }
    if ($ == undefined) $ = jQuery.noConflict();
    var triggerElement = $('#' + triggerSelector);
    var contents = $(triggerElement).attr('contents');
    var calloutInstance = $("#calloutTemplate").clone(false).attr("id", calloutId);
    var calloutContentsInstance = $("#calloutContents", calloutInstance);
    $("a", calloutInstance).click(function () { triggerElement.btOff(); });

    if (contents != null) {
        calloutContentsInstance.html(contents);
    }
    else {
        $(contentsSelector).clone().appendTo(calloutContentsInstance);
    }
    calloutInstance.addClass('tooltip');
    triggerElement.bt({
        //centerPointY: .1,
        positions: ['right'],
        contentSelector: calloutInstance,
        trigger: 'none',        
        width: 400,
        spikeGirth: 50,
        spikeLength: 40,
        cornerRadius: 10,
        offsetParent: 'body',
        fill: "#FFF",
        shadow: true,
        strokeStyle: '#283B48',
        cssStyles: {
            fontFamily: '"lucida grande",tahoma,verdana,arial,sans-serif',
            fontSize: '18px'
        },
        closeWhenOthersOpen: true
    });

    triggerElement.btOn();
}


function getValidationExp(vParm) {
    var v = vParm.data;
    var ctl = getFieldID(v.fid);
    var cval = $(ctl).val();
    var retFinValue  ;
    if (v.fid != null && v.fid != "" && v.vstr != null && v.vstr.length > 0 && cval != "") {
        $(v.vstr).each(function (index) {
            var retValue;
            if (this.toString() == "") 
                retValue = false;
            else if ((new RegExp(this.toString())).test(cval)) {
                retValue = true;
            }
            else
                retValue = false;
            if (retFinValue != undefined)
                retFinValue = retFinValue || retValue;
            else
                retFinValue = retValue;
        });
        return retFinValue;
    }
    return true ;
}

function getValidationCond(vParm, ismask) {
    var v = vParm;
    var ctl = getFieldID(v.FieldID);
    var cval = getFieldValue(v.FieldID);
    var arrayFV = v.FieldValue.split(",");
    if ((cval == null || cval == "") && ismask==false) {
        return true;
    }
    else if ( v.FieldValue == cval) {
        return true;
    }
    else if (jQuery.isArray(arrayFV) && jQuery.inArray(cval,arrayFV)>=0) {
        return true;
    }
    return false;
}

function evaluatecondition(vParam,ismask) {
    var retCond = true;
    $(vParam).each(function () {
        var retCondition = getValidationCond(this, ismask);
        retCond = retCond && retCondition;
    });
    return retCond;
}

function applymasking(vParm, onload) {
    var v = vParm;
    var ctl = getFieldID(v.fid);
    var mstr = vParm.mstr;
    if (onload == true) {
        var newval = $($(jQuery('<input name="myname" value="' + ctl.val() + '">')).mask(mstr)).val();
        if (newval != undefined && newval != '' && newval.length < ctl.val().length) {
            $(ctl).attr('donotmaskunitlvalueblank','true');
        }        
    }
    $(ctl).mask(mstr);
}

function applynonmasking(vParm) {
    var v = vParm;
    var ctl = getFieldID(v.fid);
    if($(ctl).attr('isMask')=='true')
        $(ctl).unmask();
    $(ctl).removeAttr('isMask');
}

function processMasking(vParm,onload) {
    var v = vParm;
    var retCond = evaluatecondition(v.cond,true);
    var ctl = getFieldID(v.fid);
    if (onload == false) {
        if ($(ctl).attr('cond') == undefined)
            $(ctl).attr('cond', retCond)
        else
            $(ctl).attr('cond', ($(ctl).attr('cond') == "true" ? true : false) || retCond);
    }    
    if (retCond == true) {
        applymasking(v,onload);
    }
    else if($(ctl).attr('cond')=="false") {
        applynonmasking(v);
        $(ctl).removeAttr('cond');
    }
}

//Array colfld= new Array();
$(document).ready(function () {

    if (typeof (validationlibrary) != "undefined") {
        $(validationlibrary).each(function () {
            $(this.f).each(function () {
                var ctl = $("input[name='objectButtonsStrip0$saveButton']");
                if (ctl.is("input[type='submit']")) {
                    ctl.click(this, function (event) {
                        var retValidation = getValidationExp(event);
                        var retCond = evaluatecondition(event.data.cond, false);

                        if (retCond == true && retValidation == false) {
                            showAlterMessage(event.data.errmsg, event.data.vid);
                            return false;
                        }
                        else {
                            removeMessage(event.data.vid);
                        }
                    });
                }
                if (this.mstr != null && this.mstr != "") {
                    var valf = this;
                    processMasking(this, true);
                    $(this.cond).each(function () {
                        var ctl = getFieldID(this.FieldID);
                        ctl.change(valf, function (event) {
                            var fctl = getFieldID(event.data.fid);
                            if ($(fctl).attr('cnt') == undefined)
                                $(fctl).attr('cnt', 1);
                            else
                                $(fctl).attr('cnt', parseInt($(fctl).attr('cnt')) + 1);
                           
                            processMasking(event.data, false);
                            if ($(fctl).attr('cnt') == event.data.fcnt) {
                                $(fctl).removeAttr('cond');
                                $(fctl).removeAttr('cnt');
                            }
                        });
                    });
                }

            });
        });
    }
});
		